// ************************************************************************************************
// 12.12.07
// sw_071212_02
// testweise mal timer_a neu...kein timer_b...neue ISR fr timer_a
// rtc_ta.s43 raus...
// --> die messroutinen laufen langsamer ab, als eigentlich gefordert d.h. die routine fr 1min
// braucht ca. 1min2s
// ************************************************************************************************
// ************************************************************************************************
// includes
// ************************************************************************************************
#include "owndef.h"                                 // eigene defines
#include "lcd.h"                                    // alle noetigen sachen fuer das display
#include "RTC_Calendar.h"                           // RealTimeClock bibliothek
//#include "RTC_TA.h"                                 // RealTimeClock timerA routine
#include "math.h"                                   // mathematische funktionen (z.b. log10)
#include "lut_ueff_02.h"                            // LookUpTable fuer effektivwert-kanal
#include "lut_upeak_03.h"                           // LookUpTable fuer peakwert-kanal
#include "lut_pow_02.h"                             // LookUpTable fuer 10^x
#include "lut_gain_01.h"                            // LookUpTable fuer die verstaerkung des pga
#include "my_globals.h"                             // globale variablen
#include "my_functions.h"                           // alle eigenen funktionen
#include "mmc.h"                                    // header fuer das schreiben auf sd-card
#include <stdio.h>
#include <string.h>                                 // string-handling
// ************************************************************************************************
#if( LCD_VERSION != 0x0100 )
  #error "Falsche LCD Version"
#endif
// ************************************************************************************************
// HAUPTPROGRAMM
// ************************************************************************************************
void main()
{
// ************************************************************************************************
// definition lokaler variablen
// ************************************************************************************************
  WORD TastZaehl      = 0;                          // variable fuer tastenentprellung 
// ************************************************************************************************
  WDTCTL=WDTPW+WDTHOLD;                             // stoppt den WDT
  init_mcu();                                       // initialisierungsachen fuer den controller
// ************************************************************************************************
// einstellen und starten der uhrzeit nach reset
// ************************************************************************************************
  TI_dayLightZone = EU_DAYLIGHT_SAVINGS;            // setzt variable fr eu-sommerzeitumstellung
  setDate(2007, 12, 11);                            // inititialiesieren des datums auf 11.12.2007
  setTime(0x01, 0x00, 0x00, 0);                     // inititialisieren der zeit auf 01:00:00 AM
  //TA_1sec_wake();                                   // configure TA for 1 second update
  get_date_and_time();                              // erstmaliges holen des datums und der uhrzeit
// ************************************************************************************************
  for (;;)                                          // beginn endlosschleife for(;;)
  {
// ************************************************************************************************ 
// messroutine zu jedem tick
// ************************************************************************************************
    if ((Tick != tnext) && (kalibrierung_laeuft != 1))
    {
      tnext = Tick;
// kanal 1 wandeln
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten   
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert   
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen
    
      Lequ = LUT_UEFF_02[adcwert];                  // eff-pegel aus lut holen
      
      if (Mode == 1)                                // im line-mode aus dem elektrischen signal den
      {                                             // schallpegel bestimmen      
        Gain_aktuell = LUT_GAIN_01[PGA_WERT];       // bestimmung der aktuellen verstaerkung
        if      (Wichtung == 1)
        {
          delta_1 = Lequ/10 - Kalib_LequA_el_5s_neu;// bestimmung der elektr. pegeldifferenz
          delta_2 = Gain_aktuell - Gain_eff_A;      // bestimmung der verstaerkungsdifferenz    
        }
        else if (Wichtung == 2)
        {
          delta_1 = Lequ/10 - Kalib_LequB_el_5s_neu;// bestimmung der elektr. pegeldifferenz
          delta_2 = Gain_aktuell - Gain_eff_B;      // bestimmung der verstaerkungsdifferenz       
        }
        else if (Wichtung == 3)
        {
          delta_1 = Lequ/10 - Kalib_LequC_el_5s_neu;// bestimmung der elektr. pegeldifferenz
          delta_2 = Gain_aktuell - Gain_eff_C;      // bestimmung der verstaerkungsdifferenz         
        }
        delta   = delta_1 + delta_2;                // bestimmung der gesamtdifferenz
        Lequ    = Kalib_Regelgrenze + 10*delta;     // bestimmung des neuen schallpegels
        if (Lequ < 6680) Lequ = 6680;               // damit man im messbereich bleibt
        if (Lequ > 14250) Lequ = 14250;             // damit man im messbereich bleibt             
      }
      
      if (Mode == 2)                                // im mic-mode korrekturwerte addieren
      {
        if      (Wichtung == 1) Lequ = Lequ + K_LequA;
        else if (Wichtung == 2) Lequ = Lequ + K_LequB;
        else if (Wichtung == 3) Lequ = Lequ + K_LequC;
      }
      // pegel werden zurueckgewandelt in spannungen und dann aufsummiert      
      Summe_Lequ = (QWORD)Summe_Lequ + (QWORD)LUT_POW_02[(Lequ-6680)/10];                                                  
    
      sum_adcwert_1s = sum_adcwert_1s + adcwert;    // summe der adcwerte fr 1s (kanal 1)
   
// kanal 2 wandeln
      ADC12MCTL0 = INCH_1 + SREF_1;                 // P6.1
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert1 = ADC12MEM0;                         // wandlerwerte in adcwert1   
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen
    
      Lpeak = LUT_UPEAK_03[adcwert1];               // peak-pegel aus lut
      
      if (Mode == 1)                                // im line-mode aus dem elektrischen signal den
      {                                             // schallpegel bestimmen
        // hier die bestimmung des peak-schallpegels
        
        if (Lpeak < 664) Lpeak = 664;             // damit man im messbereich bleibt
        if (Lpeak > 1376) Lpeak = 1376;           // damit man im messbereich bleibt
      }
    
      if (Mode == 2) {Lpeak = Lpeak + K_LpeakC;}    // im mic-mode korrekturwert addieren  
       
      BitSetzen(3,PEAK_RESET);                      // peakschaltkreis zuruecksetzen
      wait(3600);                                   // kurz warten...
      BitLoeschen(3,PEAK_RESET);                    // bit wieder lschen
                                                    // der peakschaltkreis wird EINMAL geloescht,
                                                    // um beim naechsten schleifendurchlauf erneut 
                                                    // einen peak erfassen zu koennen                                                    
      if (Lpeak > Lpeak_1s) Lpeak_1s = Lpeak;       // peak fuer 1s bestimmen                                                  

      sum_adcwert1_1s = sum_adcwert1_1s + adcwert1; // summe der adcwerte fr 1s (kanal 2)
    
      t1next++;                                     // "tick-zaehler" fuer 1s-routine erhhen
      teiler_1s = t1next;                           // teiler fuer 1 sekunde bestimmen
    }// ende messroutine zu jedem tick  
// ************************************************************************************************
// ************************************************************************************************
// routine jede sekunde
// ************************************************************************************************
    if ((t1next == ((32768-1)/ZEITBASIS)) && (kalibrierung_laeuft != 1))
                                                    // 32768/ (32768/ 8) = 8 (8*125ms = 1s)
    {
      // gemittelte wandlerwerte fuer bestimmung der grenzen fuer kennlinie der ad-wandler
      // bestimmung des mittelwertes der wandlerwerte (kanal-1) fr 1 sekunde
      mw_adcwert_1s  = sum_adcwert_1s/teiler_1s;    
      // bestimmung des mittelwertes der wandlerwerte (kanal-2) fr 1 sekunde                                             
      mw_adcwert1_1s = sum_adcwert1_1s/teiler_1s;
               
      // berechnung des mittleren, equivalenten schallpegels fuer 1 sekunde
      Lequ_1s = 1000*log10(Summe_Lequ/teiler_1s);
      Lequ_1s = runden(Lequ_1s);                    // gerundeter wert
      Lpeak_1s_neu    = Lpeak_1s;                   // variable speichern fuer anzeige
      
      // brechnungen fuer 5s werte                                   
      Summe_Lequ_5s = (QWORD)Summe_Lequ_5s + (QWORD)Summe_Lequ;                                                    
      teiler_5s     = teiler_5s + teiler_1s;
      if (Lpeak_1s > Lpeak_5s) Lpeak_5s = Lpeak_1s;
      t5next = t5next + 1;    
      
      // brechnungen fuer 10s werte
      Summe_Lequ_10s = (QWORD)Summe_Lequ_10s + (QWORD)Summe_Lequ;
      teiler_10s     = teiler_10s + teiler_1s;
      if (Lpeak_1s > Lpeak_10s) Lpeak_10s = Lpeak_1s;
      t10next = t10next + 1;
      
      // brechnungen fuer 20s werte
      Summe_Lequ_20s = (QWORD)Summe_Lequ_20s + (QWORD)Summe_Lequ;
      teiler_20s     = teiler_20s + teiler_1s;
      if (Lpeak_1s > Lpeak_20s) Lpeak_20s = Lpeak_1s;
      t20next = t20next + 1;
      
      // brechnungen fuer 30s werte
      Summe_Lequ_30s = (QWORD)Summe_Lequ_30s + (QWORD)Summe_Lequ;
      teiler_30s     = teiler_30s + teiler_1s;
      if (Lpeak_1s > Lpeak_30s) Lpeak_30s = Lpeak_1s;
      t30next = t30next + 1;
      
      // brechnungen fuer 40s werte
      Summe_Lequ_40s = (QWORD)Summe_Lequ_40s + (QWORD)Summe_Lequ;
      teiler_40s     = teiler_40s + teiler_1s;
      if (Lpeak_1s > Lpeak_40s) Lpeak_40s = Lpeak_1s;
      t40next = t20next + 1;
      
      // brechnungen fuer 50s werte
      Summe_Lequ_50s = (QWORD)Summe_Lequ_50s + (QWORD)Summe_Lequ;
      teiler_50s     = teiler_50s + teiler_1s;
      if (Lpeak_1s > Lpeak_50s) Lpeak_50s = Lpeak_1s;
      t50next = t20next + 1;
      
      // brechnungen fuer 1m werte (=60s)
      Summe_Lequ_1m = (QWORD)Summe_Lequ_1m + (QWORD)Summe_Lequ;
      teiler_1m     = teiler_1m + teiler_1s;
      if (Lpeak_1s > Lpeak_1m) Lpeak_1m = Lpeak_1s;
      t1mnext = t1mnext + 1;
      
      // brechnungen fuer 30m werte (=3600s)
      Summe_Lequ_30m = (QWORD)Summe_Lequ_30m + (QWORD)Summe_Lequ;
      teiler_30m     = teiler_30m + teiler_1s;
      if (Lpeak_1s > Lpeak_30m) Lpeak_30m = Lpeak_1s;
      t30mnext = t30mnext + 1;
       
      // variablen zuruecksetzen
      sum_adcwert_1s = 0;
      sum_adcwert1_1s = 0;
      t1next = 0; teiler_1s = 0; Summe_Lequ = 0; Lpeak_1s = 0;          
    }// ende routine jede sekunde
// ************************************************************************************************
// ************************************************************************************************
// routine alle 5 sekunden
// ************************************************************************************************
    if ((t5next == 5) && (kalibrierung_laeuft != 1))// 5 mal 1s-routine durchlaufen??
    {  
      // berechnung des mittleren, equivalenten schallpegels fuer 5 sekunden   
      Lequ_5s = 1000*log10(Summe_Lequ_5s/teiler_5s);
      Lequ_5s = runden(Lequ_5s);                    // gerundeter wert      
      Lpeak_5s_neu    = Lpeak_5s;                   // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t5next = 0; teiler_5s = 0; Summe_Lequ_5s = 0; Lpeak_5s = 0;
    }// ende routine alle 5 sekunden
// ************************************************************************************************
// ************************************************************************************************
// routine alle 10 sekunden
// ************************************************************************************************
    if ((t10next == 10) && (kalibrierung_laeuft != 1))// 10* 1-sekunde vergangen?
    {
      // berechnung des mittleren, equivalenten schallpegels fuer 10 sekunden
      Lequ_10s = 1000*log10(Summe_Lequ_10s/teiler_10s);
      Lequ_10s = runden(Lequ_10s);                  // gerundeter wert
      Lpeak_10s_neu   = Lpeak_10s;                  // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t10next = 0; teiler_10s = 0; Summe_Lequ_10s = 0; Lpeak_10s = 0;
    }// ende routine alle 10 sekunden
// ************************************************************************************************
// ************************************************************************************************
// routine alle 20 sekunden
// ************************************************************************************************
    if ((t20next == 20) && (kalibrierung_laeuft != 1))// 20* 1-sekunde vergangen?
    {
      // berechnung des mittleren, equivalenten schallpegels fuer 20 sekunden
      Lequ_20s = 1000*log10(Summe_Lequ_20s/teiler_20s);
      Lequ_20s = runden(Lequ_20s);                  // gerundeter wert    
      Lpeak_20s_neu   = Lpeak_20s;                  // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t20next = 0; teiler_20s = 0; Summe_Lequ_20s = 0; Lpeak_20s = 0;
    }// ende routine alle 20 sekunden
// ************************************************************************************************
// ************************************************************************************************
// routine alle 30 sekunden
// ************************************************************************************************
    if ((t30next == 30) && (kalibrierung_laeuft != 1))// 30* 1-sekunde vergangen?
    {
      // berechnung des mittleren, equivalenten schallpegels fuer 30 sekunden
      Lequ_30s = 1000*log10(Summe_Lequ_30s/teiler_30s);
      Lequ_30s = runden(Lequ_30s);                  // gerundeter wert
      Lpeak_30s_neu   = Lpeak_30s;                  // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t30next = 0; teiler_30s = 0; Summe_Lequ_30s = 0; Lpeak_30s = 0;
    }// ende routine alle 30 sekunden
// ************************************************************************************************
// ************************************************************************************************
// routine alle 40 sekunden
// ************************************************************************************************
    if ((t40next == 40) && (kalibrierung_laeuft != 1))// 40* 1-sekunde vergangen?
    {
      // berechnung des mittleren, equivalenten schallpegels fuer 40 sekunden
      Lequ_40s = 1000*log10(Summe_Lequ_40s/teiler_40s);
      Lequ_40s = runden(Lequ_40s);                  // gerundeter wert
      Lpeak_40s_neu   = Lpeak_40s;                  // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t40next = 0; teiler_40s = 0; Summe_Lequ_40s = 0; Lpeak_40s = 0;
    }// ende routine alle 40 sekunden
// ************************************************************************************************
// ************************************************************************************************
// routine alle 50 sekunden
// ************************************************************************************************
    if ((t50next == 50) && (kalibrierung_laeuft != 1))// 50* 1-sekunde vergangen?
    {
      // berechnung des mittleren, equivalenten schallpegels fuer 50 sekunden
      Lequ_50s = 1000*log10(Summe_Lequ_50s/teiler_50s);
      Lequ_50s = runden(Lequ_50s);                  // gerundeter wert
      Lpeak_50s_neu   = Lpeak_50s;                  // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t50next = 0; teiler_50s = 0; Summe_Lequ_50s = 0; Lpeak_50s = 0;
    }// ende routine alle 50 sekunden
// ************************************************************************************************    
// ************************************************************************************************
// routine jede volle minute
// werte werden nicht angezeigt, sondern dienen der protokollierung auf sd-card
// ************************************************************************************************
    if ((t1mnext == 60) && (kalibrierung_laeuft != 1))// 60* 1-sekunde vergangen?
    {
      // berechnung des mittleren, equivalenten schallpegels fuer 1 minute
      Lequ_1m = 1000*log10(Summe_Lequ_1m/teiler_1m);  
      Lequ_1m = runden(Lequ_1m);                      // gerundeter wert     
      Lpeak_1m_neu    = Lpeak_1m;                     // variable speichern fuer anzeige
      protokoll_t1mnext = t1mnext;                    // variable speichern fuer protokollierung
      
      // variablen zuruecksetzen
      t1mnext = 0; teiler_1m = 0; Summe_Lequ_1m = 0; Lpeak_1m = 0;
    }// ende routine jede volle minute
// ************************************************************************************************
// ************************************************************************************************
// routine alle 30 minuten
// ************************************************************************************************
    if ((t30mnext == 1800) && (kalibrierung_laeuft != 1)) // 1800* 1-sekunde vergangen?
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 30 minuten   
      Lequ_30m = 1000*log10(Summe_Lequ_30m/teiler_30m);
      Lequ_30m = runden(Lequ_30m);                      // gerundeter wert         
      Lpeak_30m_neu   = Lpeak_30m;                      // variable speichern fuer anzeige
      
      // variablen zuruecksetzen
      t30mnext = 0; teiler_30m = 0; Summe_Lequ_30m = 0; Lpeak_30m = 0;
    }// ende routine alle 30 minuten
// ************************************************************************************************
// ************************************************************************************************
// routine fuer tastenentprellung
// ************************************************************************************************
  BYTE Taste = 0;
//  if (kalibrierung_laeuft !=1)                      // wenn kalibrierung laeuft, dann soll keine
//  {                                                 // taste aktiv sein!
  if (!((P3IN&UP)&&(P3IN&LEFT)&&(P3IN&SET)&&(P3IN&RIGHT)&&(P4IN&DOWN)&&(P4IN&PGA))&&(TastZaehl==0))
  {
    if      ((P3IN & UP)    == 0)  Taste = 1;       // fr taster UP 
    else if ((P3IN & LEFT)  == 0)  Taste = 2;       // fr taster LEFT
    else if ((P3IN & SET)   == 0)  Taste = 3;       // fr taster SET
    else if ((P3IN & RIGHT) == 0)  Taste = 4;       // fr taster RIGHT
    else if ((P4IN & DOWN)  == 0)  Taste = 5;       // fr taster DOWN
    else if ((P4IN & PGA)   == 0)  Taste = 6;       // fr taster PGA
    TastZaehl++;
  }
  else
  {
    if ((TastZaehl == ENTPRELLZAHL) || (TastZaehl == 0)) TastZaehl = 0;
    else TastZaehl++;
//  }
  }// ende routine fuer tastenentprellung         
// ************************************************************************************************
// ************************************************************************************************
// routine zum ansteuern des pga per taster
// mit jeden tastendruck wird die daempfung des pga um xx-schritte zurueckgenommen
// nur aktiv, falls pga daempft!! (pga_wert < 192)
// ************************************************************************************************
  
  // wenn taste 6 gedrueckt wird, soll der pga_wert um eins erhoeht werden...
  if ((Taste == 6)&&(PGA_WERT < PGA_WERT_0dB))
  {
    PGA_WERT = PGA_WERT + PGA_INKREMENT_TASTE;      // pga_wert erhoehen
    pga_auf_wert(PGA_WERT);                         // neuen wert an pga senden
    taster_pga_gedrueckt = 1;                       // anzeige, dass der taster gedrueckt wurde
  }// ende routine zum ansteuern des pga per taster
  
  
  // testweise nur mal mit taste 6 das umschalten zwischen line-rauschen
  //if      ((Taste == 6) && (line == 0)) {P4OUT |=  STSIG_1; line = 1;}  // rauschen an...
  //else if ((Taste == 6) && (line == 1)) {P4OUT &= ~STSIG_1; line = 0;}  // xlr an...
  // testweise umschalten line-mode/ mic-mode
  //if      ((Taste == 6) && (Mode == 1)) Mode = 2;
  //else if ((Taste == 6) && (Mode == 2)) Mode = 1; 
// ************************************************************************************************
// ************************************************************************************************
// routine zum einstellen des ADG452 (durchschalten des jeweiligen filters)
// ************************************************************************************************
  // signal filter-a durchschalten
  if      (Wichtung == 1) {P4OUT &= ~(STSIG_4 + STSIG_5); P4OUT |= STSIG_3;}
  // signal filter-b durchschalten
  else if (Wichtung == 2) {P4OUT &= ~(STSIG_3 + STSIG_5); P4OUT |= STSIG_4;}
  // signal filter-c durchschalten
  else if (Wichtung == 3) {P4OUT &= ~(STSIG_3 + STSIG_4); P4OUT |= STSIG_5;}
  // ende routine zum einstellen des ADG452
// ************************************************************************************************
// ************************************************************************************************
// routine zum umstellen lin/ mic-mode
// ************************************************************************************************
  if      (Mode == 1) P4OUT &= ~STSIG_2;            // relais 2 wieder auf "normal" --> line-mode
  else if (Mode == 2) P4OUT |= STSIG_2;             // relais 2 schaltet auf mic-mode um 
// ************************************************************************************************
// ************************************************************************************************
// routine zum ansteuern der gefahren-led
// ************************************************************************************************
  if (Lequ_1s > 9500)
  {
    P2OUT |= LED_UEBER95;                                           // led >95dB an
    if (Lequ_1s > 9900){P2OUT &= ~LED_UEBER95; P2OUT |= LED_UEBER99;}// led >95dB aus, led >99dB an
    else P2OUT &= ~LED_UEBER99;                                     // led >99dB aus
  }
  else {P2OUT &= ~LED_UEBER95; P2OUT &= ~LED_UEBER99;}              // beide leds wieder aus
// ************************************************************************************************
// ************************************************************************************************
// routine zum ansteuern der PGA-led
// led geht an, falls PGA_WERT_0dB < 192; d.h. er daempft
// ************************************************************************************************
  if (PGA_WERT < PGA_WERT_0dB) P4OUT |= LED_PGA;    // LED_PGA geht an                                 
  else P4OUT &= ~LED_PGA;                           // ansonsten LED_PGA wieder aus 
// ************************************************************************************************
// ************************************************************************************************
// routine fr led line-/mic-mode an/ aus
// ************************************************************************************************
  if      (Mode == 1) {P2OUT |= LED_LINE; P2OUT &= ~LED_MIC;} // line-led an, mic-led aus
  else if (Mode == 2) {P2OUT |= LED_MIC; P2OUT &= ~LED_LINE;} // mic-led an, line-led aus
// ************************************************************************************************
// ************************************************************************************************
// routine fr sd-led an bei bestimmter zeit
// ************************************************************************************************
  if (sd_s_gesetzt == 1)
  {
    if (sd_s_min == mymin)
    {
      if ((sd_s_hour == myhour) && (sd_s_PM == TI_PM))
      {
        if (sd_s_day == myday)
        {
          if (sd_s_month == mymonth)
          {
           if (sd_s_year == myyear)
           {
            P2OUT |= LED_SD;                                  // wenn alles stimmt, dann sd-led an
            protokoll_laeuft = 1;
           }                                                                                                                 
          }
        }
      }
    }
  }// ende routine fr sd-led an bei bestimmter zeit
// ************************************************************************************************
// ************************************************************************************************
// routine fr sd-led aus bei bestimmter zeit
// ************************************************************************************************
  if (sd_e_gesetzt == 1)
  {
    if (sd_e_min == mymin)
    {
      if ((sd_e_hour == myhour) && (sd_e_PM == TI_PM))
      {
        if (sd_e_day == myday)
        {
          if (sd_e_month == mymonth)
          {
            if (sd_e_year == myyear)
            {
              P2OUT &= ~LED_SD;                     // wenn alles stimmt, dann sd-led aus
              protokoll_laeuft = 0;                 // variable zuruecksetzen
              sd_s_gesetzt = 0;                     // variable zuruecksetzen
              sd_e_gesetzt = 0;                     // variable zuruecksetzen
              // zum ende der protokollierung muss von hier aus geschrieben werden, weil die
              // variable protokoll_laeuft zurueckgesetzt wurde...
              // der buffer soll ja aber noch geschrieben werden!
              // schreibt buffer auf sd-card              
              mmcWriteSector(sektor, (unsigned char*) buffer);
              loesche_buffer();                     // lscht den buffer
              ++sektor;                             // sektor erhoehen
              protokoll_zaehler = 0;                // variable zuruecksetzen
            }                                                            
          }
        }
      }
    }
  }// ende routine fr sd-led aus bei bestimmter zeit
// ************************************************************************************************
// ************************************************************************************************
// routine fuer protokollierung
// ************************************************************************************************
  if (protokoll_laeuft == 1)
  {
    
    // initialisierung der mmc/sd-card
    while (status != 0)                             // if return in not NULL an error did occur and                                                   
    {                                               // the MMC/SD-card will be initialized again 
      status = initMMC();
      timeout++;
      // Try 50 times till error
      if (timeout == 50) {printf ("No MMC/SD-card found!! %x\n", status); break;}
    }

    while ((mmc_ping() != MMC_SUCCESS));            // warte, bis karte eingesetzt wurde  
  
    // wenn der kopf noch nicht geschrieben wurde, dann schreiben des protokoll-kopfes
    // sektor wird um 1 erhoeht
    if (protokoll_kopf_geschrieben == 0) {schreibe_protokoll_kopf();}
    
    // alle 60sekunden in diese routine rein
    if (protokoll_t1mnext == 60)
    {    
        strcat (buffer, "\r\n");                    // zeilenumbruch
        // es werden 30 zeilen a 16 zeichen in den buffer geschrieben --> 30*16 = 480 bytes
        // man koennte auch 32 zeilen schreiben, aber zur sicherheit lieber eine weinger
        // wegen "ende-zeichen"
        // nach einer halben stunde wird buffer geschrieben
        strcat (buffer, zahl2ascii2(Lequ_1m));      // ausgabe des mittleren pegels
        strcat (buffer, "  ");
        strcat (buffer, zahl2ascii2(Lpeak_1m_neu)); // ausgabe des spitzenpegels der letzten min.
        strcat (buffer, " ");
        // abfrage, ob pga_taster gedrueckt wurde
        if (taster_pga_gedrueckt == 1) strcat (buffer, "*");  
        else strcat (buffer, " ");
        
        protokoll_zaehler = protokoll_zaehler + 1;  // schleifenzaehler wird erhoeht
        taster_pga_gedrueckt = 0;                   // variable zuruecksetzen

      // schreibt buffer auf sd-card und erhoeht den sektor
      // die letzten 31 werte und dann auch noch das halbstundenmittel, sowie der halbstunden-peak
      if (protokoll_zaehler == 30)
      {
        strcat (buffer, "\r\n");
        strcat (buffer, "--------------");          // trennzeichen fuer die letzte halbe stunde
        // schreibt buffer auf sd-card
        mmcWriteSector(sektor, (unsigned char*) buffer);
        loesche_buffer();                           // lscht den buffer
        ++sektor;                                   // sektor erhoehen
        protokoll_zaehler = 0;                      // variable zuruecksetzen
      }     
      protokoll_t1mnext = 0;                        // variable zuruecksetzen
    }  
  mmc_GoIdle();                                     // setzen mmc/sd-card in den idle-mode 
  }  
// ende routine fuer protokollierung
// ************************************************************************************************
// ************************************************************************************************
// routine fuer kalibrierung
// ************************************************************************************************
if (kalibrierung_laeuft == 1)
{
  BYTE k = 0;
  BYTE j = 0;
 
// kalibrierung fuer a-bewertetes signal
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

  // anzeige, das a-bewertete kalibrierung gerade luft                                   
  LCD_Cursor_Set(0,0);
  LCD_Awrite("Kalib. a-bewertet   ");
  LCD_Cursor_Set(1,0);
  LCD_Awrite("l");
  LCD_Write(BUCHSTABE_AE);
  LCD_Awrite("uft! Bitte Warten!");
  
  pga_auf_wert(PGA_WERT_MIN);                       // setzt PGA_WERT auf 1 (-95.5dB)
  //kalibrierung_a_bewertet = 1;                      // anzeige, dass a-bewertete kalib. laeuft
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
  
  P4OUT &= ~STSIG_2;                                // relais 2 schaltet auf line-mode um
  P2OUT |= LED_LINE; P2OUT &= ~LED_MIC;             // line-led an, mic-led aus
  // umstellen des filters auf a-wichtung
  P4OUT &= ~(STSIG_4 + STSIG_5);                    // die beiden anderen filter aus
  P4OUT |= STSIG_3;                                 // signal filter-a durchschalten
  
  P4OUT |= STSIG_1;                                 // relais 1 schaltet auf rauschen um
  
  BitSetzen(3,PEAK_RESET);                          // vor dem wandeln erstmal den peak-schaltkreis                                                    
  wait(3600);                                       // zuruecksetzen
  BitLoeschen(3,PEAK_RESET);
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
// kalib_routine jeden tick
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA  
  // einmessen des rauschgenarators
  while (k != 1)
  { 
    // ad-wandlung beginnen
    if (Tick != tnext)
    {
      tnext = Tick;
      // kanal 1 wandeln
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten    
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert   
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen     
      Kalib_LequA_el = LUT_UEFF_02[adcwert];        // eff-pegel aus lut holen                  
      // pegel werden zurueckgewandelt in spannungen und dann aufsummiert
      Kalib_Summe_Lequ = (QWORD)Kalib_Summe_Lequ + (QWORD)LUT_POW_02[(Kalib_LequA_el-6680)/10];
                                                       
      // kanal 2 wandeln
      // muss nur einmal gemacht werden, da bei der b- und c-wichtung ja das gleiche gemacht werden
      // wuerde...
      ADC12MCTL0 = INCH_1 + SREF_1;                 // P6.1
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert1 = ADC12MEM0;                         // wandlerwerte in adcwert1   
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen    
      Kalib_LpeakC_el = LUT_UPEAK_03[adcwert1];     // peak-pegel aus lut
       
      BitSetzen(3,PEAK_RESET);                      // peakschaltkreis zuruecksetzen
      wait(3600);                                   // kurz warten...
      BitLoeschen(3,PEAK_RESET);                    // bit wieder lschen
                                                    // der peakschaltkreis wird EINMAL geloescht,
                                                    // um beim naechsten schleifendurchlauf erneut 
                                                    // einen peak erfassen zu koennen
      // maximalwert fuer 1s bestimmen                                                  
      if (Kalib_LpeakC_el > Kalib_LpeakC_el_1s) Kalib_LpeakC_el_1s = Kalib_LpeakC_el;                                                                                        
    
      t1next++;                                     // "tick-zaehler" fuer 1s-routine erhhen
      teiler_1s = t1next;                           // teiler fuer 1 sekunde bestimmen     
      /*
      // anzeige der werte     
      LCD_Cursor_Set(0,0);
      LCD_Zahl(adcwert,4,0);
      LCD_Awrite(" ");
      LCD_Zahl2(Kalib_LequA_el/10);
      LCD_Awrite(" ");
      LCD_Zahl(adcwert1,4,0);
      LCD_Awrite(" ");
      LCD_Zahl2(Kalib_LpeakC_el/10);
      */     
    }// ende messroutine zu jedem tick  
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
// kalib_routine jede sekunde
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    if (t1next == (32768/ZEITBASIS))                // 32768/ (32768/ 8) = 8 (8*125ms = 1s)
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 1 sekunde    
      Kalib_LequA_el_1s = 1000*log10(Kalib_Summe_Lequ/teiler_1s);         
      Kalib_LequA_el_1s = runden(Kalib_LequA_el_1s);// gerundeter wert
      
      
      // berechnung fr 5s-mittel                                        
      Kalib_Summe_Lequ_5s = (QWORD)Kalib_Summe_Lequ_5s + (QWORD)Kalib_Summe_Lequ;
      // berechnung des teilers fuer 5 sekunden                                                     
      teiler_5s = teiler_5s + teiler_1s;        
      // neuen peak-wert bestimmen
      if (Kalib_LpeakC_el_1s > Kalib_LpeakC_el_5s) Kalib_LpeakC_el_5s = Kalib_LpeakC_el_1s;
      // variable speichern fuer anzeige
      Kalib_LequA_el_1s_neu  = Kalib_LequA_el_1s;
      Kalib_LpeakC_el_1s_neu = Kalib_LpeakC_el_1s;                    

      t1next              = 0;
      teiler_1s           = 0;
           
      Kalib_Summe_Lequ    = 0;
      Kalib_LpeakC_el_1s  = 0;
      
      t5next++;                                     // "tick-zaehler" fuer 5s-routine erhhen
      
      // anzeige der werte
      //LCD_Cursor_Set(1,0);   
      //LCD_Zahl(Kalib_LequA_el_1s_neu/10,4,1);
      //LCD_Zahl(Kalib_LpeakC_el_1s_neu/10,4,1);                                      
    }// ende routine jede sekunde
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
// kalib_routine alle 5 sekunde
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    if (t5next == 5)                                // 5 mal 1s-routine durchlaufen??
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 5 sekunden 
      Kalib_LequA_el_5s = 1000*log10(Kalib_Summe_Lequ_5s/teiler_5s);      
      Kalib_LequA_el_5s = runden(Kalib_LequA_el_5s);// gerundeter wert
            
      // variablen speichern
      Kalib_LequA_el_5s_neu  = Kalib_LequA_el_5s;     
      Kalib_LpeakC_el_5s_neu = Kalib_LpeakC_el_5s;                   

      t5next              = 0;
      teiler_5s           = 0;
      
      Kalib_Summe_Lequ_5s = 0;
      Kalib_LpeakC_el_5s  = 0;
      // damit die for-schleife zum einmessen des rauschgenerators beendet wird...
      k                   = 1;    
      // anzeige der werte
      //LCD_Zahl(Kalib_LequA_el_5s_neu/10,4,1);
      //LCD_Zahl(Kalib_LpeakC_el_5s_neu/10,4,1);                     
    }// ende routine alle 5 sekunde
// AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
  }// ende while-schleife fuer einmessen des rauschgenerators
       
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
   
  // jetzt wird der schallpegel vom mikro gemessen, der vom rauschgenerator erzeugt wird...           
  P4OUT |= STSIG_2;                                 // relais 2 schaltet auf mic-mode um 
  P2OUT |= LED_MIC; P2OUT &= ~LED_LINE;             // mic-led an, line-led aus
    
  // durchfahren des pga
  while (j != 1)
  {                                                 
    // wandelt kanal 1; funktion gibt eff-pegel zurueck                     
    if (Tick != tnext)
    { 
      tnext = Tick;   
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert    
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen       
      Kalib_Lequ = LUT_UEFF_02[adcwert];            // eff-pegel aus lut holen
      Kalib_Lequ = Kalib_Lequ + K_LequA;            // korrekturwert addieren    
    }
    // routine zum ansteuern der gefahren-led 
    if (Kalib_Lequ > 9500)
    {
      P2OUT |= LED_UEBER95;                         // led >95dB an
      // led >95dB aus; led >99dB an
      if (Kalib_Lequ > 9900) {P2OUT &= ~LED_UEBER95; P2OUT |= LED_UEBER99;}               
      else P2OUT &= ~LED_UEBER99;                   // led >99dB aus
    }
    else {P2OUT &= ~LED_UEBER95; P2OUT &= ~LED_UEBER99;}// beide leds wieder aus                  
    // ende routine zum ansteuern der gefahren-led
    
    // routine zum ansteuern der PGA-led
    if (PGA_WERT < PGA_WERT_0dB) P4OUT |= LED_PGA;  // LED_PGA geht an                                 
    else P4OUT &= ~LED_PGA;                         // ansonsten LED_PGA wieder aus
    // ende routine zum ansteuern der PGA-led
        
    // hochregeln des pga bis zur regelgrenze
    // damit beim ersten testen kalib_lequ nicht > regelgrenze ist, wird mit regelgrenze +70dB
    // (70dB == 7000) verglichen. k.a. warum das so ist!                               
    if (Kalib_Lequ < (Kalib_Regelgrenze + Kalib_diff_erstes_messen))
    { 
      PGA_WERT = PGA_WERT + PGA_INKREMENT;          // pga-wert erhoehen
      pga_auf_wert(PGA_WERT);                       // neuen pga-wert senden
      // wartezeit, damit man das hochfahren sieht!
      wait(8000);
      // nach 10 durchlaeufen die variable zuruecksetzen
      // nach 10 durchlaufen ist der pga immer noch bei bei rund -91dB verstaerkung --> reicht also
      if (PGA_WERT == 10) Kalib_diff_erstes_messen = 0;
    }
    else
    {
      // speichern des gain; "-1", damit man auf jeden fall UNTER der regelgrenze bleibt!             
      Gain_eff_A = LUT_GAIN_01[PGA_WERT-1];
      j = 1;                                        // variable setzen zum while-schleife beenden..
    }    
    LCD_Cursor_Set(0,0);
    LCD_Zahl(PGA_WERT,3,0);                         // ausgabe pga_wert
    LCD_Awrite(" ");
    if (PGA_WERT <= PGA_WERT_0dB) LCD_Awrite("-");
    else LCD_Awrite("+");
    LCD_Zahl(fabs(LUT_GAIN_01[PGA_WERT]),3,1);      // ausgabe der verstaerkung des pga
    LCD_Awrite(" ");
    LCD_Zahl(Kalib_Lequ/10,4,1);                       // ausgabe des vom mic gemessenen schallpegels
    LCD_Awrite("dB  ");
    LCD_Cursor_Set(1,0);
    LCD_Awrite("Bitte Warten!       ");        
  }// ende while-schleife durchfahren des pga
  //kalibrierung_a_bewertet = 0;         
// ende kalibrierung fuer a-bewertetes signal 
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB  
// kalibrierung fuer b-bewertetes signal 
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
  k = 0;                                            // laufvariable zuruecksetzen
  j = 0;                                            // laufvariable zuruecksetzen
  
  // anzeige, das b-bewertete kalibrierung gerade luft                                   
  LCD_Cursor_Set(0,0);
  LCD_Awrite("Kalib. b-bewertet   ");
  LCD_Cursor_Set(1,0);
  LCD_Awrite("l");
  LCD_Write(BUCHSTABE_AE);
  LCD_Awrite("uft! Bitte Warten!");
  
  pga_auf_wert(PGA_WERT_MIN);                       // setzt PGA_WERT auf 1 (-95.5dB)
  //kalibrierung_b_bewertet = 1;                      // anzeige, dass b-bewertete kalib. laeuft
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
  
  P4OUT &= ~STSIG_2;                                // relais 2 schaltet auf line-mode um
  P2OUT |= LED_LINE; P2OUT &= ~LED_MIC;             // line-led an, mic-led aus
  // umstellen des filters auf b-wichtung
  P4OUT &= ~(STSIG_3 + STSIG_5);                    // die beiden anderen filter aus
  P4OUT |= STSIG_4;                                 // signal filter-b durchschalten
  
  P4OUT |= STSIG_1;                                 // relais 1 schaltet auf rauschen um
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
// kalib_routine jeden tick
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB   
  // einmessen des rauschgenarators
  while (k != 1)
  { 
    // ad-wandlung beginnen
    if (Tick != tnext)
    {
      tnext = Tick;
      // kanal 1 wandeln
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten    
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert   
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen      
      Kalib_LequB_el = LUT_UEFF_02[adcwert];        // eff-pegel aus lut holen                  
      // pegel werden zurueckgewandelt in spannungen und dann aufsummiert
      Kalib_Summe_Lequ = (QWORD)Kalib_Summe_Lequ + (QWORD)LUT_POW_02[(Kalib_LequB_el-6680)/10];                                                                                                                                             
    
      t1next++;                                     // "tick-zaehler" fuer 1s-routine erhoehen
      teiler_1s = t1next;                           // teiler fuer 1 sekunde bestimmen     
      /*
      // anzeige der werte     
      LCD_Cursor_Set(0,0);
      LCD_Zahl(adcwert,4,0);
      LCD_Awrite(" ");
      LCD_Zahl2(Kalib_LequB_el/10);
      LCD_Awrite(" ");
      LCD_Zahl(adcwert1,4,0);
      //LCD_Awrite(" ");
      //LCD_Zahl2(Kalib_LpeakC_el/10);
      */     
    }// ende messroutine zu jedem tick  
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
// kalib_routine jede sekunde
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
    if (t1next == (32768/ZEITBASIS))                // 32768/ (32768/ 8) = 8 (8*125ms = 1s)
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 1 sekunde    
      Kalib_LequB_el_1s = 1000*log10(Kalib_Summe_Lequ/teiler_1s);         
      Kalib_LequB_el_1s = runden(Kalib_LequB_el_1s);// gerundeter wert
      
      // berechnung fr 5s-mittel                                        
      Kalib_Summe_Lequ_5s = (QWORD)Kalib_Summe_Lequ_5s + (QWORD)Kalib_Summe_Lequ;
      // berechnung des teilers fuer 5 sekunden                                                     
      teiler_5s = teiler_5s + teiler_1s;        
      // variable speichern fuer anzeige
      Kalib_LequB_el_1s_neu  = Kalib_LequB_el_1s;                    

      t1next              = 0;
      teiler_1s           = 0;
           
      Kalib_Summe_Lequ    = 0;
      
      t5next++;                                     // "tick-zaehler" fuer 5s-routine erhhen      
      // anzeige der werte
      //LCD_Cursor_Set(1,0);   
      //LCD_Zahl(Kalib_LequB_el_1s_neu/10,4,1);                                     
    }// ende routine jede sekunde
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
// kalib_routine alle 5 sekunde
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
    if (t5next == 5)                                // 5 mal 1s-routine durchlaufen??
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 5 sekunden 
      Kalib_LequB_el_5s = 1000*log10(Kalib_Summe_Lequ_5s/teiler_5s);     
      Kalib_LequB_el_5s = runden(Kalib_LequB_el_5s);// gerundeter wert
            
      // variablen speichern
      Kalib_LequB_el_5s_neu  = Kalib_LequB_el_5s;                       

      t5next              = 0;
      teiler_5s           = 0;
      
      Kalib_Summe_Lequ_5s = 0;
      // damit die for-schleife zum einmessen des rauschgenerators beendet wird...
      k                   = 1;    
      // anzeige der werte
      //LCD_Zahl(Kalib_LequB_el_5s_neu/10,4,1);                    
    }// ende routine alle 5 sekunde
// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB 
  }// ende while-schleife fuer einmessen des rauschgenerators
       
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
   
  // jetzt wird der schallpegel vom mikro gemessen, der vom rauschgenerator erzeugt wird...           
  P4OUT |= STSIG_2;                                 // relais 2 schaltet auf mic-mode um 
  P2OUT |= LED_MIC; P2OUT &= ~LED_LINE;             // mic-led an, line-led aus
  
  // durchfahren des pga
  while (j != 1)
  {                                                 
    // wandelt kanal 1; funktion gibt eff-pegel zurueck                     
    if (Tick != tnext)
    { 
      tnext = Tick;   
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert    
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen       
      Kalib_Lequ = LUT_UEFF_02[adcwert];            // eff-pegel aus lut holen
      Kalib_Lequ = Kalib_Lequ + K_LequB;            // korrekturwert addieren    
    }
    // routine zum ansteuern der gefahren-led 
    if (Kalib_Lequ > 9500)
    {
      P2OUT |= LED_UEBER95;                         // led >95dB an
      // led >95dB aus; led >99dB an
      if (Kalib_Lequ > 9900) {P2OUT &= ~LED_UEBER95; P2OUT |= LED_UEBER99;}               
      else P2OUT &= ~LED_UEBER99;                   // led >99dB aus
    }
    else {P2OUT &= ~LED_UEBER95; P2OUT &= ~LED_UEBER99;}// beide leds wieder aus                  
    // ende routine zum ansteuern der gefahren-led
    // routine zum ansteuern der PGA-led
    if (PGA_WERT < PGA_WERT_0dB) P4OUT |= LED_PGA;  // LED_PGA geht an                                 
    else P4OUT &= ~LED_PGA;                         // ansonsten LED_PGA wieder aus
    // ende routine zum ansteuern der PGA-led
        
    // hochregeln des pga bis zur regelgrenze
    // damit beim ersten testen kalib_lequ nicht > regelgrenze ist, wird mit regelgrenze +70dB
    // (70dB == 7000) verglichen. k.a. warum das so ist!                              
    if (Kalib_Lequ < (Kalib_Regelgrenze + Kalib_diff_erstes_messen))
    { 
      PGA_WERT = PGA_WERT + PGA_INKREMENT;          // pga-wert erhoehen
      pga_auf_wert(PGA_WERT);                       // neuen pga-wert senden
      // wartezeit, damit man das hochfahren sieht!
      wait(8000);
      // nach 10 durchlaeufen die variable zuruecksetzen
      // nach 10 durchlaufen ist der pga immer noch bei bei rund -91dB verstaerkung --> reicht also
      if (PGA_WERT == 10) Kalib_diff_erstes_messen = 0;
    }
    else
    {
      // speichern des gain; "-1", damit man auf jeden fall UNTER der regelgrenze bleibt!
      Gain_eff_B = LUT_GAIN_01[PGA_WERT-1];              
      j = 1;                                        // variable setzen zum while-schleife beenden..
    }    
    LCD_Cursor_Set(0,0);
    LCD_Zahl(PGA_WERT,3,0);                         // ausgabe pga_wert
    LCD_Awrite(" ");
    if (PGA_WERT <= PGA_WERT_0dB) LCD_Awrite("-");
    else LCD_Awrite("+");
    LCD_Zahl(fabs(LUT_GAIN_01[PGA_WERT]),3,1);      // ausgabe der verstaerkung des pga
    LCD_Awrite(" ");
    LCD_Zahl(Kalib_Lequ/10,4,1);                       // ausgabe des vom mic gemessenen schallpegels
    LCD_Awrite("dB  ");
    LCD_Cursor_Set(1,0);
    LCD_Awrite("Bitte Warten!       ");         
  }// ende while-schleife durchfahren des pga
  //kalibrierung_b_bewertet = 0;  
// ende kalibrierung fuer b-bewertetes signal 
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
// kalibrierung fuer c-bewertetes signal 
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
  k = 0;                                            // laufvariable zuruecksetzen
  j = 0;                                            // laufvariable zuruecksetzen
  
  // anzeige, das b-bewertete kalibrierung gerade luft                                   
  LCD_Cursor_Set(0,0);
  LCD_Awrite("Kalib. c-bewertet   ");
  LCD_Cursor_Set(1,0);
  LCD_Awrite("l");
  LCD_Write(BUCHSTABE_AE);
  LCD_Awrite("uft! Bitte Warten!");
  
  pga_auf_wert(PGA_WERT_MIN);                       // setzt PGA_WERT auf 1 (-95.5dB)
  //kalibrierung_c_bewertet = 1;                      // anzeige, dass c-bewertete kalib. laeuft
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
  
  P4OUT &= ~STSIG_2;                                // relais 2 schaltet auf line-mode um
  P2OUT |= LED_LINE; P2OUT &= ~LED_MIC;             // line-led an, mic-led aus
  // umstellen des filters auf b-wichtung
  P4OUT &= ~(STSIG_3 + STSIG_4);                    // die beiden anderen filter aus
  P4OUT |= STSIG_5;                                 // signal filter-c durchschalten
  
  P4OUT |= STSIG_1;                                 // relais 1 schaltet auf rauschen um
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
// kalib_routine jeden tick
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC   
  // einmessen des rauschgenarators
  while (k != 1)
  { 
    // ad-wandlung beginnen
    if (Tick != tnext)
    {
      tnext = Tick;
      // kanal 1 wandeln
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten   
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert    
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen      
      Kalib_LequC_el = LUT_UEFF_02[adcwert];        // eff-pegel aus lut holen                  
      // pegel werden zurueckgewandelt in spannungen und dann aufsummiert
      Kalib_Summe_Lequ = (QWORD)Kalib_Summe_Lequ + (QWORD)LUT_POW_02[(Kalib_LequC_el-6680)/10];                                                                                                                                             
    
      t1next++;                                     // "tick-zaehler" fuer 1s-routine erhhen
      teiler_1s = t1next;                           // teiler fuer 1 sekunde bestimmen     
      /*
      // anzeige der werte     
      LCD_Cursor_Set(0,0);
      LCD_Zahl(adcwert,4,0);
      LCD_Awrite(" ");
      LCD_Zahl2(Kalib_LequC_el/10);
      LCD_Awrite(" ");
      LCD_Zahl(adcwert1,4,0);
      //LCD_Awrite(" ");
      //LCD_Zahl2(Kalib_LpeakC_el/10);
      */     
    }// ende messroutine zu jedem tick  
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
// kalib_routine jede sekunde
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
    if (t1next == (32768/ZEITBASIS))                // 32768/ (32768/ 8) = 8 (8*125ms = 1s)
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 1 sekunde    
      Kalib_LequC_el_1s = 1000*log10(Kalib_Summe_Lequ/teiler_1s);         
      Kalib_LequC_el_1s = runden(Kalib_LequC_el_1s);// gerundeter wert
      
      // berechnung fr 5s-mittel                                        
      Kalib_Summe_Lequ_5s = (QWORD)Kalib_Summe_Lequ_5s + (QWORD)Kalib_Summe_Lequ;
      // berechnung des teilers fuer 5 sekunden                                                     
      teiler_5s = teiler_5s + teiler_1s;        
      // variable speichern fuer anzeige
      Kalib_LequC_el_1s_neu  = Kalib_LequC_el_1s;                    

      t1next              = 0;
      teiler_1s           = 0;
           
      Kalib_Summe_Lequ    = 0;
      
      t5next++;                                     // "tick-zaehler" fuer 5s-routine erhhen      
      // anzeige der werte
      //LCD_Cursor_Set(1,0);   
      //LCD_Zahl(Kalib_LequC_el_1s_neu/10,4,1);                                     
    }// ende routine jede sekunde
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
// kalib_routine alle 5 sekunde
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
    if (t5next == 5)                                // 5 mal 1s-routine durchlaufen??
    { 
      // berechnung des mittleren, equivalenten schallpegels fuer 5 sekunden 
      Kalib_LequC_el_5s = 1000*log10(Kalib_Summe_Lequ_5s/teiler_5s);     
      Kalib_LequC_el_5s = runden(Kalib_LequC_el_5s);// gerundeter wert aus lut
            
      // variablen speichern
      Kalib_LequC_el_5s_neu  = Kalib_LequC_el_5s;                       

      t5next              = 0;
      teiler_5s           = 0;
      
      Kalib_Summe_Lequ_5s = 0;
      // damit die for-schleife zum einmessen des rauschgenerators beendet wird...
      k                   = 1;    
      // anzeige der werte
      //LCD_Zahl(Kalib_LequC_el_5s_neu/10,4,1);                    
    }// ende routine alle 5 sekunde
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
  }// ende while-schleife fuer einmessen des rauschgenerators
       
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
   
  // jetzt wird der schallpegel vom mikro gemessen, der vom rauschgenerator erzeugt wird...           
  P4OUT |= STSIG_2;                                 // relais 2 schaltet auf mic-mode um 
  P2OUT |= LED_MIC; P2OUT &= ~LED_LINE;             // mic-led an, line-led aus
  
  // durchfahren des pga
  while (j != 1)
  {                                                 
    // wandelt kanal 1; funktion gibt eff-pegel zurueck                     
    if (Tick != tnext)
    { 
      tnext = Tick;   
      ADC12MCTL0 = INCH_0 + SREF_1;                 // P6.0
      ADC12CTL0 |= ENC + ADC12SC;                   // ADC12 starten
      while ((ADC12IFG & BIT0)==0);                 // warte auf wandlungsende
      adcwert = ADC12MEM0;                          // wandlerwerte in adcwert    
      ADC12CTL0 &= ~ENC;                            // ADC12 stoppen       
      Kalib_Lequ = LUT_UEFF_02[adcwert];            // eff-pegel aus lut holen
      Kalib_Lequ = Kalib_Lequ + K_LequC;            // korrekturwert addieren    
    }
    // routine zum ansteuern der gefahren-led 
    if (Kalib_Lequ > 9500)
    {
      P2OUT |= LED_UEBER95;                         // led >95dB an
      // led >95dB aus; led >99dB an
      if (Kalib_Lequ > 9900) {P2OUT &= ~LED_UEBER95; P2OUT |= LED_UEBER99;}               
      else P2OUT &= ~LED_UEBER99;                   // led >99dB aus
    }
    else {P2OUT &= ~LED_UEBER95; P2OUT &= ~LED_UEBER99;}// beide leds wieder aus                  
    // ende routine zum ansteuern der gefahren-led
    // routine zum ansteuern der PGA-led
    if (PGA_WERT < PGA_WERT_0dB) P4OUT |= LED_PGA;  // LED_PGA geht an                                 
    else P4OUT &= ~LED_PGA;                         // ansonsten LED_PGA wieder aus
    // ende routine zum ansteuern der PGA-led
        
    // hochregeln des pga bis zur regelgrenze
    // damit beim ersten testen kalib_lequ nicht > regelgrenze ist, wird mit regelgrenze +70dB
    // (70dB == 7000) verglichen. k.a. warum das so ist!                               
    if (Kalib_Lequ < (Kalib_Regelgrenze + Kalib_diff_erstes_messen))
    { 
      PGA_WERT = PGA_WERT + PGA_INKREMENT;          // pga-wert erhoehen
      pga_auf_wert(PGA_WERT);                       // neuen pga-wert senden
      // wartezeit, damit man das hochfahren sieht!
      wait(8000);
      // nach 10 durchlaeufen die variable zuruecksetzen
      // nach 10 durchlaufen ist der pga immer noch bei bei rund -91dB verstaerkung --> reicht also
      if (PGA_WERT == 10) Kalib_diff_erstes_messen = 0;
    }
    else
    {
      // speichern des gain; "-1", damit man auf jeden fall UNTER der regelgrenze bleibt!             
      Gain_eff_C = LUT_GAIN_01[PGA_WERT-1];
      j = 1;                                        // variable setzen zum while-schleife beenden..
    }    
    LCD_Cursor_Set(0,0);
    LCD_Zahl(PGA_WERT,3,0);                         // ausgabe pga_wert
    LCD_Awrite(" ");
    if (PGA_WERT <= PGA_WERT_0dB) LCD_Awrite("-");
    else LCD_Awrite("+");
    LCD_Zahl(fabs(LUT_GAIN_01[PGA_WERT]),3,1);      // ausgabe der verstaerkung des pga
    LCD_Awrite(" ");
    LCD_Zahl(Kalib_Lequ/10,4,1);                       // ausgabe des vom mic gemessenen schallpegels
    LCD_Awrite("dB  ");
    LCD_Cursor_Set(1,0);
    LCD_Awrite("Bitte Warten!       ");         
  }// ende while-schleife durchfahren des pga
  //kalibrierung_C_bewertet = 0;
// ende kalibrierung fuer c-bewertetes signal 
// CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
  kalibrierung_laeuft = 0;                          // variable zuruecksetzen
                                                    // anzeige, dass kalibrierung zu ende ist                                              
  LCD_Cursor_Set(0,0);
  LCD_Awrite("Kalibrierung beendet");
  LCD_Cursor_Set(1,0);
  LCD_Awrite("                    ");   
  P4OUT &= ~STSIG_1;                                // rauschen wieder aus...                               
  Mode   = 1;                                       // line-mode an
  setze_alle_adc12_zurueck();                       // alle adc12 variablen zuruecksetzen
  wait(130000);
  Seite  = 12;                                      // nach der kalibrierung zurueck zur seite 12                                                               
}// ende routine kalibrierung
// ************************************************************************************************
// ************************************************************************************************
// routine fuer regelung des musiksignales
// ************************************************************************************************










// ************************************************************************************************
// ************************************************************************************************
// routine fr tastensteuerung
// ************************************************************************************************
    switch (Seite)
    {
// seite 0 anzeige 1s-messwerte
      case 0:
        if      (Taste == 1) Seite = 1;
        else if ((Taste == 2) || (Taste == 4)) Seite = 4;
        else if (Taste == 3) Seite = 5;
        else if (Taste == 5) Seite = 3;
      break;  
// seite 1 anzeige 5s messwerte
      case 1:
        if      (Taste == 1) Seite = 2;
        else if (Taste == 3) Seite = 5;
        else if (Taste == 5) Seite = 0;
      break;
// seite 2 anzeige 30min messwerte
      case 2:
        if      (Taste == 1) Seite = 3;
        else if (Taste == 3) Seite = 5;
        else if (Taste == 5) Seite = 1;
      break;        
// seite 3 anzeige datum und uhrzeit
      case 3:
        if      (Taste == 1) Seite = 0;
        else if (Taste == 3) Seite = 5;
        else if (Taste == 5) Seite = 2;
      break;
// seite 4 anzeige wartung1
      case 4:
        if      (Taste == 1) Seite = 50;
        else if (Taste == 5) Seite = 49;
        else if ((Taste == 2) || (Taste == 4)) Seite = 0;
      break;
// seite 49 anzeige wartung2
      case 49:
        if      (Taste == 1) Seite = 4;
        else if (Taste == 5) Seite = 50;
        else if (Taste == 2)
        {
          PGA_WERT = PGA_WERT + 1;                  // PGA_WERT um 1 erhoehen          
          pga_auf_wert(PGA_WERT);                   // neuen pga-wert setzen
        }
        else if (Taste == 4)
        {
          PGA_WERT = PGA_WERT - 1;                  // PGA_WERT um 1 verringern          
          pga_auf_wert(PGA_WERT);                   // neuen pga-wert setzen
        }
      break;
// seite 50 anzeige wartung3
      case 50:
        if      (Taste == 1) Seite = 49;
        else if (Taste == 5) Seite = 4;      
      break;           
// seite 5 anzeige setup datum und uhrzeit
      case 5:
        if      (Taste == 1) Seite = 12;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1) {Seite = 6; myPM = TI_PM;}
            else Seite = 48;          
          }        
        else if (Taste == 5) Seite = 47;              
      break;
// seite 6 einstellen tag
      case 6:
        if      (Taste == 2) Seite = 11;
        else if (Taste == 4) Seite = 7;
        else if (Taste == 3) set_date_and_time();
        else if (Taste == 1)
        {
          myday++;                                      // hochsetzen des tages
          if (myday > 31) myday = 1;
        }
        else if (Taste == 5)
        {
          myday--;                                      // runtersetzen des tages
          if (myday < 1) myday = 31;
        }
      break;
// seite 7 einstellen monat
      case 7:
        if      (Taste == 2) Seite = 6;
        else if (Taste == 4) Seite = 8;
        else if (Taste == 3) set_date_and_time();
        else if (Taste == 1)
        {
          mymonth++;                                    // hichsetzen des monats
          if (mymonth > 12) mymonth = 1;
        }
        else if (Taste == 5)
        {
          mymonth--;                                    // runtersetzen des monats
          if (mymonth < 1) mymonth = 12;
        }
      break;
// seite 8 einstellen jahr
      case 8:
        if      (Taste == 2) Seite = 7;
        else if (Taste == 4) Seite = 9;
        else if (Taste == 3) set_date_and_time();
        else if (Taste == 1)
        {
          myyear++;                                     // hochsetzen des jahres
          if (myyear > 2020) myyear = 2007;
        }
        else if (Taste == 5)
        {
          myyear--;                                     // runterstetzen des jahres
          if (myyear < 2007) myyear = 2020;
        }
      break;
// seite 9 einstellen stunde
      case 9:
        if      (Taste == 2) Seite = 8;
        else if (Taste == 4) Seite = 10;
        else if (Taste == 3) set_date_and_time();
        else if (Taste == 1)                            
        {                                               
          myhour++;                                     // hochsetzen der stunden 
          if ( myhour > 11)                             
          {                                             
            myPM = 1;                                   
            if (myhour > 23) {myPM = 0; myhour = 0;}    
          }                                             
          else myPM = 0;                                
        }                                               
        else if (Taste == 5)                           
        {                                               
          myhour--;                                     // runterstezen der stunden
          if (myhour < 12)                              
          {                                             
            myPM = 0;                                   
            if (myhour < 0) {myPM = 1; myhour = 23;}    
          }                                             
          else myPM = 1;                                
        }                                               
      break;
// seite 10 einstellen minute
      case 10:
        if      (Taste == 2) Seite = 9;
        else if (Taste == 4) Seite = 11;
        else if (Taste == 3) set_date_and_time();
        else if (Taste == 1)                            
        {                                               
          mymin++;                                      // hochsetzen der minuten
          if (mymin > 59) mymin = 0;                    
        }                                                
        else if (Taste == 5)                            
        {                                               
          mymin--;                                      // runtersetzen der minuten
          if (mymin <  0) mymin = 59;                   
        }                                               
      break;
// seite 11 einstellen sekunden
      case 11:
        if      (Taste == 2) Seite = 10;
        else if (Taste == 4) Seite = 6;
        else if (Taste == 3) set_date_and_time();
        else if (Taste == 1)                            
        {                                               
          mysec++;                                      // hochsetzen der sekunden
          if (mysec > 59) mysec = 0;                    
        }                                                
        else if (Taste == 5)                            
        {                                               
          mysec--;                                      // runtersetzen der sekunden
          if (mysec <  0) mysec = 59;                   
        }                                                 
      break;
// seite 12 setup kalibrierung
      case 12:
        if      (Taste == 1) Seite = 25;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1) Seite = 13;
            else Seite = 48;          
          }          
        else if (Taste == 5) Seite = 5;
      break;
// seite 13 setup regelgrenze
      case 13:
        if      (Taste == 1) Seite = 15;
        else if (Taste == 3) Seite = 14;
        else if (Taste == 5) Seite = 23;
      break;
// seite 14 einstellen regelgrenze
      case 14:
        if      (Taste == 3) Seite = 13;
        if      (Taste == 1)
        {
          Regelgrenze = Regelgrenze + 100;
          if (Regelgrenze > MAXIMALLAUTSTAERKE) Regelgrenze = MINIMALLAUTSTAERKE;
        }
        else if (Taste == 5)
        {
          Regelgrenze = Regelgrenze - 100;
          if (Regelgrenze < MINIMALLAUTSTAERKE) Regelgrenze = MAXIMALLAUTSTAERKE;
        } 
      break;
// seite 15 setup korrekturwert K_LequA
      case 15:
        if      (Taste == 1) Seite = 23;
        else if (Taste == 2) Seite = 18;
        else if (Taste == 3) Seite = 19;
        else if (Taste == 4) Seite = 16;
        else if (Taste == 5) Seite = 13;
      break;
// seite 16 setup korrekturwert K_LequB
      case 16:
        if      (Taste == 1) Seite = 23;
        else if (Taste == 2) Seite = 15;
        else if (Taste == 3) Seite = 20;
        else if (Taste == 4) Seite = 17;
        else if (Taste == 5) Seite = 13;
      break;
// seite 17 setup korrekturwert K_LequC
      case 17:
        if      (Taste == 1) Seite = 23;
        else if (Taste == 2) Seite = 16;
        else if (Taste == 3) Seite = 21;
        else if (Taste == 4) Seite = 18;
        else if (Taste == 5) Seite = 13;
      break;
// seite 18 setup korrekturwert K_LpeakC
      case 18:
        if      (Taste == 1) Seite = 23;
        else if (Taste == 2) Seite = 17;
        else if (Taste == 3) Seite = 22;
        else if (Taste == 4) Seite = 15;
        else if (Taste == 5) Seite = 13;
      break;
//seite 19 einstellen korrekturwert K_LequA
      case 19:
        if      (Taste == 3) Seite = 15;
        if      (Taste == 1)
        {
          K_LequA = K_LequA + 100;
          if (K_LequA > MAXIMALKORREKTUR) K_LequA = 0;
        }
        else if (Taste == 5)
        {
          K_LequA = K_LequA - 100;
          if (K_LequA < 0) K_LequA = MAXIMALKORREKTUR;
        } 
      break;
//seite 20 einstellen korrekturwert K_LequB
      case 20:
        if      (Taste == 3) Seite = 15;
        if      (Taste == 1)
        {
          K_LequB = K_LequB + 100;
          if (K_LequB > MAXIMALKORREKTUR) K_LequB = 0;
        }
        else if (Taste == 5)
        {
          K_LequB = K_LequB - 100;
          if (K_LequB < 0) K_LequB = MAXIMALKORREKTUR;
        } 
      break; 
//seite 21 einstellen korrekturwert K_LequC
      case 21:
        if      (Taste == 3) Seite = 15;
        if      (Taste == 1)
        {
          K_LequC = K_LequC + 100;
          if (K_LequC > MAXIMALKORREKTUR) K_LequC = 0;
        }
        else if (Taste == 5)
        {
          K_LequC = K_LequC - 100;
          if (K_LequC < 0) K_LequC = MAXIMALKORREKTUR;
        } 
      break;
//seite 22 einstellen korrekturwert K_LpeakC
      case 22:
        if      (Taste == 3) Seite = 15;
        if      (Taste == 1)
        {
          K_LpeakC = K_LpeakC + 10;
          if (K_LpeakC*10 > MAXIMALKORREKTUR) K_LpeakC = 0;
        }
        else if (Taste == 5)
        {
          K_LpeakC = K_LpeakC - 10;
          if (K_LpeakC*10 < 0) K_LpeakC = MAXIMALKORREKTUR;
        } 
      break;                               
// seite 23 kalibrierung starten?
      case 23:
        if      (Taste == 1) Seite = 13;
        else if (Taste == 2) Seite = 12;
        else if (Taste == 4) {/*Seite = 24;*/ kalibrierung_laeuft = 1;}
        else if (Taste == 5) Seite = 15;
      break;
// seite 24 anzeige, dass kalibrierung gerade luft...
  // keine tasten aktiv
// seite 25 setup line/mic-mode
      case 25:
        if      (Taste == 1) Seite = 28;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1) Seite = 26;
            else Seite = 48;          
          }  
        else if (Taste == 5) Seite = 12;  
      break;
// seite 26 einstellen line-mode
      case 26:
        if      ((Taste == 2) || (Taste == 4)) Seite = 27;
        else if (Taste == 3) {Seite = 25; Mode = 1;}// auf line-mode setzen
      break;
// seite 27 einstellen mic-mode
      case 27:
        if      ((Taste == 2) || (Taste == 4)) Seite = 26;
        else if (Taste == 3) {Seite = 25; Mode = 2;}// auf mic-mode setzen         
      break;      
// seite 28 setup wichtung
      case 28:
        if      (Taste == 1) Seite = 32;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1) Seite = 29;
            else Seite = 48;          
          }   
        else if (Taste == 5) Seite = 25;
      break;
// seite 29 einstellen wichtung a
      case 29:
        if      (Taste == 2) Seite = 31;
        else if (Taste == 3) {Seite = 28; Wichtung = 1;}// wichtung auf a-filter umstellen
        else if (Taste == 4) Seite = 30;
      break;
// seite 30 einstellen wichtung b
      case 30:
        if      (Taste == 2) Seite = 29;
        else if (Taste == 3) {Seite = 28; Wichtung = 2;}// wichtung auf b-filter umstellen
        else if (Taste == 4) Seite = 31;
      break;
// seite 31 einstellen wichtung c
      case 31:
        if      (Taste == 2) Seite = 30;
        else if (Taste == 3) {Seite = 28; Wichtung = 3;}// wichtung auf c-filter umstellen          
        else if (Taste == 4) Seite = 29;
      break;
// seite 32 setup startzeit sd-protokoll
      case 32:
        if      (Taste == 1) Seite = 39;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1)
              {
                //if (check_sd_card_status() != 3) Seite = 33;
                if ((check_sd_card_status() == 1) || (check_sd_card_status() == 2)) Seite = 33;
                else Seite = 34; 
              }           
            else Seite = 48;          
          }                     
        else if (Taste == 5) Seite = 28;
      break;
// seite 33 fehler-seite fr sd_card_status
      case 33:
        if (Taste == 3) Seite = 32;  
      break;
// seite 34 einstellen tag
      case 34:
        if      (Taste == 2) Seite = 38;
        else if (Taste == 4) Seite = 35;
        else if (Taste == 3) {Seite = 32; sd_s_gesetzt = 1; protokoll_kopf_geschrieben = 0;}
        else if (Taste == 1)
        {
          sd_s_day++;
          if (sd_s_day > 31) sd_s_day = 1;
        }
        else if (Taste == 5)
        {
          sd_s_day--;
          if (sd_s_day < 1) sd_s_day = 31;
        }       
      break;
// seite 35 einstellen monat
      case 35:
        if      (Taste == 2) Seite = 34;
        else if (Taste == 4) Seite = 36;
        else if (Taste == 3) {Seite = 32; sd_s_gesetzt = 1; protokoll_kopf_geschrieben = 0;}
        else if (Taste == 1)
        {
          sd_s_month++;
          if (sd_s_month > 12) sd_s_month = 1;
        }
        else if (Taste == 5)
        {
          sd_s_month--;
          if (sd_s_month < 1) sd_s_month = 12;
        }
      break;
// seite 36 einstellen jahr
      case 36:
        if      (Taste == 2) Seite = 35;
        else if (Taste == 4) Seite = 37;
        else if (Taste == 3) {Seite = 32; sd_s_gesetzt = 1; protokoll_kopf_geschrieben = 0;}
        else if (Taste == 1)
        {
          sd_s_year++;
          if (sd_s_year > 2020) sd_s_year = 2007;
        }
        else if (Taste == 5)
        {
          sd_s_year--;
          if (sd_s_year < 2007) sd_s_year = 2020;
        }
      break;
// seite 37 einstellen stunde
      case 37:
        if      (Taste == 2) Seite = 36;
        else if (Taste == 4) Seite = 38;
        else if (Taste == 3) {Seite = 32; sd_s_gesetzt = 1; protokoll_kopf_geschrieben = 0;}
        else if (Taste == 1)                          
        {                                             
          sd_s_hour++;                                    
          if (sd_s_hour > 11)                           
          {                                           
            sd_s_PM = 1;                                  
            if (sd_s_hour > 23) {sd_s_PM = 0; sd_s_hour = 0;}  
          }                                            
          else sd_s_PM = 0;                             
        }                                            
        else if (Taste == 5)                      
        {                                             
          sd_s_hour--;                                   
          if (sd_s_hour < 12)                            
          {                                             
            sd_s_PM = 0;                                 
            if (sd_s_hour < 0) {sd_s_PM = 1; sd_s_hour = 23;}   
          }                                            
          else sd_s_PM = 1;                               
        }                                              
      break;
// seite 38 einstellen minute
      case 38:
        if      (Taste == 2) Seite = 37;
        else if (Taste == 4) Seite = 34;
        else if (Taste == 3) {Seite = 32; sd_s_gesetzt = 1; protokoll_kopf_geschrieben = 0;}
        else if (Taste == 1)                           
        {                                                                          
          if      (sd_s_min == 30) sd_s_min = 0;
          else if (sd_s_min ==  0) sd_s_min = 30;                   
        }                                              
        else if (Taste == 5)                         
        {                                                                        
          if      (sd_s_min == 30) sd_s_min = 0;
          else if (sd_s_min ==  0) sd_s_min = 30;      
        }                                           
      break;      
// seite 39 setup endzeit sd-protokoll
      case 39:
        if      (Taste == 1) Seite = 45;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1) Seite = 40;
            else Seite = 48;          
          }   
        else if (Taste == 5) Seite = 32;
      break;
// seite 40 einstellen tag
      case 40:
        if      (Taste == 2) Seite = 44;
        else if (Taste == 4) Seite = 41;
        else if (Taste == 3) {Seite = 39; sd_e_gesetzt = 1;}
        else if (Taste == 1)
        {
          sd_e_day++;
          if (sd_e_day > 31) sd_e_day = 1;
        }
        else if (Taste == 5)
        {
          sd_e_day--;
          if (sd_e_day < 1) sd_e_day = 31;
        }       
      break;
// seite 41 einstellen monat
      case 41:
        if      (Taste == 2) Seite = 40;
        else if (Taste == 4) Seite = 42;
        else if (Taste == 3) {Seite = 39; sd_e_gesetzt = 1;}
        else if (Taste == 1)
        {
          sd_e_month++;
          if (sd_e_month > 12) sd_e_month = 1;
        }
        else if (Taste == 5)
        {
          sd_e_month--;
          if (sd_e_month < 1) sd_e_month = 12;
        }
      break;
// seite 42 einstellen jahr
      case 42:
        if      (Taste == 2) Seite = 41;
        else if (Taste == 4) Seite = 43;
        else if (Taste == 3) {Seite = 39; sd_e_gesetzt = 1;}
        else if (Taste == 1)
        {
          sd_e_year++;
          if (sd_e_year > 2020) sd_e_year = 2007;
        }
        else if (Taste == 5)
        {
          sd_e_year--;
          if (sd_e_year < 2007) sd_e_year = 2020;
        }
      break;
// seite 43 einstellen stunde
      case 43:
        if      (Taste == 2) Seite = 42;
        else if (Taste == 4) Seite = 44;
        else if (Taste == 3) {Seite = 39; sd_e_gesetzt = 1;}
        else if (Taste == 1)                          
        {                                             
          sd_e_hour++;                                    
          if (sd_e_hour > 11)                           
          {                                           
            sd_e_PM = 1;                                  
            if (sd_e_hour > 23) {sd_e_PM = 0; sd_e_hour = 0;}  
          }                                            
          else sd_e_PM = 0;                             
        }                                            
        else if (Taste == 5)                      
        {                                             
          sd_e_hour--;                                   
          if (sd_e_hour < 12)                            
          {                                             
            sd_e_PM = 0;                                 
            if (sd_e_hour < 0) {sd_e_PM = 1; sd_e_hour = 23;}   
          }                                            
          else sd_e_PM = 1;                               
        }                                              
      break;
// seite 44 einstellen minute
      case 44:
        if      (Taste == 2) Seite = 43;
        else if (Taste == 4) Seite = 40;
        else if (Taste == 3) {Seite = 39; sd_e_gesetzt = 1;}
        else if (Taste == 1)                           
        {                                                                          
          if      (sd_e_min == 30) sd_e_min = 0;
          else if (sd_e_min ==  0) sd_e_min = 30;                   
        }                                              
        else if (Taste == 5)                         
        {                                                                        
          if      (sd_e_min == 30) sd_e_min = 0;
          else if (sd_e_min ==  0) sd_e_min = 30;      
        }                                           
      break;
// seite 45 startsektor fuer sd-card
      case 45:
        if      (Taste == 1) Seite = 47;
        else if (Taste == 3)
          {
            if (protokoll_laeuft != 1) Seite = 46;
            else Seite = 48;          
          }  
        else if (Taste == 5) Seite = 39;
      break;
// seite 46 einstellen startsektor fuer sd-card
      case 46:
        if      (Taste == 2) Seite = 45;
        else if (Taste == 4) {Seite = 45; sektor = 770;}
      break;                                                
// seite 47 "setup verlassen?"
      case 47:
        if      (Taste == 1) Seite = 5;
        else if (Taste == 3) Seite = 0;
        else if (Taste == 5) Seite = 45;
      break;
// seite 48 fehlerseite, falls protokollierung gerade laeuft --> dann keine einstellungen moeglich
      case 48:
        if      (Taste == 2) Seite = 47;            // wenn protokoll NICHT beendet werden soll
                                                    // zurueck zur seite "setup beenden?"
        else if (Taste == 4)
        { 
          strcat (buffer, "\r\n");
          strcat (buffer, "\r\n"); 
          strcat (buffer, "Abbruch durch Nutzer");
          strcat (buffer, "\r\n");
          strcat (buffer, "**************************");        
          // schreibt buffer auf sd-card, auch, wenn der buffer noch nicht voll sein sollte!
          mmcWriteSector(sektor, (unsigned char*) buffer);
          loesche_buffer();                         // loescht den buffer wieder
          ++sektor;                                 // sektor erhoehen
          protokoll_laeuft = 0;                     // variable zuruecksetzen
          P2OUT &= ~LED_SD;                         // led aus
          Seite = 47;                               // zurueck zur seite 47
        }      
      break;      
      //default;
    }//ende switch-anweisung
// ************************************************************************************************
// ************************************************************************************************
// routine fr anzeige der Seite im display
// ************************************************************************************************
    switch (Seite)
    {
// seite 0 anzeige 1s messwerte
      case 0:
        LCD_Cursor_Set(0,0);
        if (Wichtung == 1)
        {
          LCD_Awrite("LequA  1s   ");
          if ((adcwert < WANDLERWERT_EFF_O)&&(adcwert > WANDLERWERT_EFF_U)) LCD_Awrite(" ");
          else LCD_Awrite("*");                     // anzeige, dass der messbereich verlassen wird
          LCD_Zahl(Lequ_1s,4,1);
        }
        else if (Wichtung == 2)
        {
          LCD_Awrite("LequB  1s   ");
          if ((adcwert < WANDLERWERT_EFF_O)&&(adcwert > WANDLERWERT_EFF_U)) LCD_Awrite(" ");
          else LCD_Awrite("*");                     // anzeige, dass der messbereich verlassen wird
          LCD_Zahl(Lequ_1s,4,1);
        }
        else if (Wichtung == 3)
        {
          LCD_Awrite("LequC  1s   ");
          if ((adcwert < WANDLERWERT_EFF_O)&&(adcwert > WANDLERWERT_EFF_U)) LCD_Awrite(" ");
          else LCD_Awrite("*");                     // anzeige, dass der messbereich verlassen wird
          LCD_Zahl(Lequ_1s,4,1);
        }
        LCD_Awrite("dB");                           // dB aus erster zeile...         
        LCD_Cursor_Set(1,0);                        // zweite zeile
        LCD_Awrite("LpeakC 1s   ");
        if ((adcwert1 < WANLDERWERT_PEAK_O)&&(adcwert1 > WANDLERWERT_PEAK_U)) LCD_Awrite(" ");
        else LCD_Awrite("*");                       // anzeige, dass der messbereich verlassen wird
        LCD_Zahl(Lpeak_1s_neu,4,1);
        LCD_Awrite("dB");
      break;     
// seite 1 anzeige 5s messwerte
      case 1:
        LCD_Cursor_Set(0,0);
        if (Wichtung == 1)
        {
          LCD_Awrite("LequA  5s    ");
          LCD_Zahl(Lequ_5s,4,1);
        }
        else if (Wichtung == 2)
        {
          LCD_Awrite("LequB  5s    ");
          LCD_Zahl(Lequ_5s,4,1);
        }
        else if (Wichtung == 3)
        {
          LCD_Awrite("LequC  5s    ");
          LCD_Zahl(Lequ_5s,4,1);
        }
        LCD_Awrite("dB");                           // dB aus erster zeile...         
        LCD_Cursor_Set(1,0);                        // zweite zeile
        LCD_Awrite("LpeakC 5s    ");
        LCD_Zahl(Lpeak_5s_neu,4,1);
        LCD_Awrite("dB");
      break;          
// seite 1 anzeige 30min messwerte  
      case 2:
        LCD_Cursor_Set(0,0);
        if (Wichtung == 1)
        {
          LCD_Awrite("LequA  30m   ");
          LCD_Zahl(Lequ_30m,4,1);
        }
        else if (Wichtung == 2)
        {
          LCD_Awrite("LequB  30m   ");
          LCD_Zahl(Lequ_30m,4,1);
        }
        else if (Wichtung == 3)
        {
          LCD_Awrite("LequC  30m   ");
          LCD_Zahl(Lequ_30m,4,1);
        }
        LCD_Awrite("dB");                           // dB aus erster zeile...        
        LCD_Cursor_Set(1,0);                        // zweite zeile
        LCD_Awrite("LpeakC 30m   ");
        LCD_Zahl(Lpeak_30m_neu,4,1);
        LCD_Awrite("dB");
      break;
// seite 3 anzeige datum und uhrzeit
      case 3:
        get_date_and_time();                        // datum und uhrzeit aus TI-variablen holen      
        LCD_Cursor_Set(0,0);                        // zeile 0
        LCD_Awrite("Datum     ");                         
        LCD_Zahl(myday,2,0);
        LCD_Awrite(".");
        LCD_Zahl(mymonth,2,0);
        LCD_Awrite(".");
        LCD_Zahl(myyear,4,0);    
        LCD_Cursor_Set(1,0);                        // zeile 1
        LCD_Awrite("Uhrzeit     ");
        LCD_Zahl(myhour,2,0);                            
        LCD_Awrite(":");                           
        LCD_Zahl(mymin,2,0);                            
        LCD_Awrite(":");                            
        LCD_Zahl(mysec,2,0);                              
      break;           
// seite 4 anzeige wartung
      case 4:
     
        LCD_Cursor_Set(0,0);
        LCD_Zahl(Lequ_1s,4,0);                       
        LCD_Awrite(" ");
        LCD_Zahl(Lequ_5s,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lequ_30s,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lequ_1m,4,0);
        LCD_Awrite(" ");
        
        LCD_Cursor_Set(1,0);
        LCD_Zahl(Lpeak_1s_neu,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak_5s_neu,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak_30s_neu,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak_1m_neu,4,0);
        LCD_Awrite(" ");
     /*
        LCD_Cursor_Set(0,0);
        LCD_Zahl(Lequ_1s,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lequ_10s,4,0);
        LCD_Awrite(" ");
        //LCD_Zahl(Lequ_20s,4,0);
        LCD_Zahl(Lequ_30s,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lequ_50s,4,0);
        //LCD_Zahl(Lequ_40s,4,0);
        LCD_Awrite(" ");
        
        LCD_Cursor_Set(1,0);
        LCD_Zahl(Lpeak_1s_neu,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak_10s_neu,4,0);
        LCD_Awrite(" ");
        //LCD_Zahl(Lpeak_20s_neu,4,0);
        LCD_Zahl(Lpeak_30s_neu,4,0);
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak_50s_neu,4,0);
        //LCD_Zahl(Lpeak_40s_neu,4,0);
        LCD_Awrite(" ");
      */
      break;
// seite 49 anzeige wartung2
      case 49:
        LCD_Cursor_Set(0,0);       
        LCD_Zahl(PGA_WERT,3,0);                     // ausgabe des pga-wertes
        if (PGA_WERT <= PGA_WERT_0dB) LCD_Awrite("-");
        else LCD_Awrite("+");
        LCD_Zahl(fabs(LUT_GAIN_01[PGA_WERT]),3,1);
        LCD_Awrite(" ");
        LCD_Zahl(Lequ/10,4,1);
        //LCD_Zahl(Kalib_LequA_el_5s_neu,4,1);        // ausgabe des kalib_lequ_5s
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak,4,1);
        //LCD_Zahl(Kalib_LpeakC_el_5s_neu,4,1);    // ausgaben des kalib_lpeak_5s
        LCD_Cursor_Set(1,0);
        
        if (Gain_eff_A <= 0) LCD_Awrite("-");
        else LCD_Awrite("+");
        LCD_Zahl((fabs(Gain_eff_A)),3,1);
       
        LCD_Awrite("    ");
        LCD_Zahl(Lequ_1s,4,1);
        LCD_Awrite(" ");
        LCD_Zahl(Lpeak_1s_neu,4,1);
      break;
// seite 50 anzeige wartung3
      case 50:
        LCD_Cursor_Set(0,0);
        LCD_Zahl(Kalib_LequA_el_5s_neu,4,1);
        LCD_Zahl(Kalib_LequB_el_5s_neu,4,1);
        LCD_Zahl(Kalib_LequC_el_5s_neu,4,1);
        LCD_Zahl(Kalib_LpeakC_el_5s_neu,4,1);
        LCD_Cursor_Set(1,0);
        
        if (Gain_eff_A <= 0) LCD_Awrite("-");
        else LCD_Awrite("+");
        LCD_Zahl((fabs(Gain_eff_A)),3,1);
        
        if (Gain_eff_B <= 0) LCD_Awrite("-");
        else LCD_Awrite("+");
        LCD_Zahl((fabs(Gain_eff_B)),3,1);
        
        if (Gain_eff_C <= 0) LCD_Awrite("-");
        else LCD_Awrite("+");
        LCD_Zahl((fabs(Gain_eff_C)),3,1);
        LCD_Awrite("     ");
      break;            
// seite 5 anzeige setup datum und uhrzeit
      case 5:
        LCD_Cursor_Set(0,0);                        // zeile 0
        LCD_Awrite("Setup Datum&Uhrzeit ");
        LCD_Cursor_Set(1,0);                        // zeile 1
        LCD_Awrite("               >>SET");
      break;      
// seite 6 einstellen tag
      case 6:
          LCD_Cursor_Set(0,0);                      // zeile 0
          LCD_Awrite("Datum  |");
          LCD_Zahl(myday,2,0);
          LCD_Awrite("|");
          LCD_Zahl(mymonth,2,0);
          LCD_Awrite(".");
          LCD_Zahl(myyear,4,0);
          LCD_Awrite(" ");
          LCD_Write(PFEILRECHTS);                          
          setup_show_time();                        // zeile 1, feststehende uhrzeit anzeigen       
      break;
// seite 7 einstellen monat
      case 7:      
          LCD_Cursor_Set(0,0);                      // zeile 0
          LCD_Awrite("Datum   ");
          LCD_Zahl(myday,2,0);
          LCD_Awrite("|");
          LCD_Zahl(mymonth,2,0);
          LCD_Awrite("|");
          LCD_Zahl(myyear,4,0);
          LCD_Awrite(" ");
          LCD_Write(PFEILRECHTS);                          
          setup_show_time();                        // zeile 1, feststehende uhrzeit anzeigen       
      break;
// seite 8 einstellen jahr
      case 8:
          LCD_Cursor_Set(0,0);                      // zeile 0
          LCD_Awrite("Datum   ");
          LCD_Zahl(myday,2,0);
          LCD_Awrite(".");
          LCD_Zahl(mymonth,2,0);
          LCD_Awrite("|");
          LCD_Zahl(myyear,4,0);
          LCD_Awrite("|");
          LCD_Write(PFEILRECHTS);                           
          setup_show_time();                        // zeile 1, feststehende uhrzeit anzeigen      
      break;
// seite 9 einstellen stunde
      case 9:
          setup_show_date();                        // zeile 0, feststehendes datum anzeigen
          LCD_Cursor_Set(1,0);                      // zeile 1
          LCD_Awrite("Uhrzeit  |");
          LCD_Zahl(myhour,2,0);                          
          LCD_Awrite("|");                               
          LCD_Zahl(mymin,2,0);                             
          LCD_Awrite(":");                             
          LCD_Zahl(mysec,2,0);
          LCD_Awrite("  ");                             
      break;
// seite 10 einstellen minute
      case 10:
          setup_show_date();                        // zeile 0, feststehendes datum anzeigen
          LCD_Cursor_Set(1,0);                      // zeile 1
          LCD_Awrite("Uhrzeit   ");
          LCD_Zahl(myhour,2,0);                          
          LCD_Awrite("|");                                 
          LCD_Zahl(mymin,2,0);                            
          LCD_Awrite("|");                              
          LCD_Zahl(mysec,2,0);
          LCD_Awrite("  ");                             
      break;
// seite 11 einstellen sekunde
      case 11:
          setup_show_date();                        // zeile 0, feststehendes datum anzeigen
          LCD_Cursor_Set(1,0);                      // zeile 1
          LCD_Awrite("Uhrzeit   ");
          LCD_Zahl(myhour,2,0);                          
          LCD_Awrite(":");                                
          LCD_Zahl(mymin,2,0);                       
          LCD_Awrite("|");                           
          LCD_Zahl(mysec,2,0);                             
          LCD_Awrite("|");
          LCD_Awrite(" ");
      break;
// seite 12 setup kalibrierung
      case 12:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Setup Kalibrierung  ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;
// seite 13 setup regelgrenze
      case 13:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Setup Regelgrenze   ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("aktuell: ");
        LCD_Zahl(Regelgrenze/100,3,0);
        LCD_Awrite("dB >>SET");
      break;
// seite 14 einstellen regelgrenze
      case 14:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Regelgrenze: ");
        LCD_Zahl(Regelgrenze/100,3,0);
        LCD_Awrite("dB  ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;
// seite 15 setup korrekturwert K_LequA
      case 15:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Setup Korrekturwert ");
        LCD_Cursor_Set(1,0);
        LCD_Write(PFEILLINKS);
        LCD_Awrite(" K_LequA (");
        LCD_Zahl(K_LequA/100,2,0);
        LCD_Awrite("dB)   ");
        LCD_Write(PFEILRECHTS);  
      break;
// seite 16 setup korrektuwert K_LequB
      case 16:
        LCD_Cursor_Set(1,0);
        LCD_Write(PFEILLINKS);
        LCD_Awrite(" K_LequB (");
        LCD_Zahl(K_LequB/100,2,0);
        LCD_Awrite("dB)   ");
        LCD_Write(PFEILRECHTS); 
      break;
// seite 17 setup korrektuwert K_LequC
      case 17:
        LCD_Cursor_Set(1,0);
        LCD_Write(PFEILLINKS);
        LCD_Awrite(" K_LequC (");
        LCD_Zahl(K_LequC/100,2,0);
        LCD_Awrite("dB)   ");
        LCD_Write(PFEILRECHTS); 
      break;
// seite 18 setup korrektuwert K_LpeakC
      case 18:
        LCD_Cursor_Set(1,0);
        LCD_Write(PFEILLINKS);
        LCD_Awrite(" K_LpeakC (");
        LCD_Zahl(K_LpeakC/100,2,0);
        LCD_Awrite("dB)  ");
        LCD_Write(PFEILRECHTS); 
      break;
// seite 19 einstellen korrektuwert K_LequA
      case 19:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("K_LequA: ");
        LCD_Zahl(K_LequA/100,2,0);
        LCD_Awrite("dB       ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET"); 
      break;
// seite 20 einstellen korrektuwert K_LequB
      case 20:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("K_LequB: ");
        LCD_Zahl(K_LequB/100,2,0);
        LCD_Awrite("dB       ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;
// seite 21 einstellen korrektuwert K_LequC
      case 21:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("K_LequC: ");
        LCD_Zahl(K_LequC/100,2,0);
        LCD_Awrite("dB       ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;
// seite 22 einstellen korrektuwert K_LpeakC
      case 22:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("K_LpeakC: ");
        LCD_Zahl(K_LpeakC/10,2,0);
        LCD_Awrite("dB      ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;                              
// seite 23 kalibrierung starten?
      case 23:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Jetzt Kalibrieren?  ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("(");
        LCD_Write(PFEILLINKS);
        LCD_Awrite(")NEIN        JA(");
        LCD_Write(PFEILRECHTS);
        LCD_Awrite(")");
      break;
// seite 24 anzeige, dass kalibrierung gerade luft
      case 24:
      // die ganzen sachen muessen in die routine fuer die kalibrierung rein...
      // sonst zeigt er nichts an...--> logisch, weil er ja IN der routine bleibt!
      break;
// seite 25 setup line/mic-mode
      case 25:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Setup Line/Mic-Mode ");
        LCD_Cursor_Set(1,0);
        if      (Mode == 1) LCD_Awrite("aktuell: Line  >>SET");
        else if (Mode == 2) LCD_Awrite("aktuell: Mic   >>SET");
      break;
// seite 26 einstellen line-mode
      case 26:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Mode w");
        LCD_Write(BUCHSTABE_AE);
        LCD_Awrite("hlen         ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("  |Line|      Mic   ");
      break;
// seite 27 einstellen mic-mode
      case 27:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Mode w");
        LCD_Write(BUCHSTABE_AE);
        LCD_Awrite("hlen         ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("   Line      |Mic|  ");
      break;      
// seite 28 setup wichtung
      case 28:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Setup Wichtung      ");
        LCD_Cursor_Set(1,0);
        if      (Wichtung == 1) LCD_Awrite("aktuell: a     >>SET"); 
        else if (Wichtung == 2) LCD_Awrite("aktuell: b     >>SET");
        else if (Wichtung == 3) LCD_Awrite("aktuell: c     >>SET");
      break;
// seite 29 einstellen wichtung a
      case 29:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Wichtungsfilter     ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("   |a|   b    c     ");
      break;
// seite 30 einstellen wichtung b
      case 30:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Wichtungsfilter     ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("    a   |b|   c     ");
      break;
// seite 31 einstellen wichtung b
      case 31:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Wichtungsfilter     ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("    a    b   |c|    ");
      break;            
// seite 32 setup startzeit sd-protokoll
      case 32:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Setup start sd-card ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;
// seite 33 fehler-seite fr sd_card_status
      case 33:
        if (sd_card_status == 1)
        {
          LCD_Cursor_Set(0,0);
          LCD_Awrite("SD-Card einsetzen!  ");
          LCD_Cursor_Set(1,0);
          LCD_Awrite("               >>SET");
        }
        if (sd_card_status == 2)
        {
          LCD_Cursor_Set(0,0);
          LCD_Awrite("Schreibschutz ent-  ");
          LCD_Cursor_Set(1,0);
          LCD_Awrite("fernen!        >>SET");
        }
      break;
// seite 34 einstellen tag
      case 34:
        LCD_Cursor_Set(0,0);                      // zeile 0
        LCD_Awrite("Datum  |");
        LCD_Zahl(sd_s_day,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_s_month,2,0);
        LCD_Awrite(".");
        LCD_Zahl(sd_s_year,4,0);
        LCD_Awrite(" ");
        LCD_Write(PFEILRECHTS);                          
        sd_s_setup_show_time();                   // zeile 1, feststehende uhrzeit anzeigen
      break;
// seite 35 einstellen monat
      case 35:
        LCD_Cursor_Set(0,0);                      // zeile 0
        LCD_Awrite("Datum   ");
        LCD_Zahl(sd_s_day,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_s_month,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_s_year,4,0);
        LCD_Awrite(" ");
        LCD_Write(PFEILRECHTS);                          
        sd_s_setup_show_time();                   // zeile 1, feststehende uhrzeit anzeigen
      break;
// seite 36 einstellen jahr
      case 36:
        LCD_Cursor_Set(0,0);                      // zeile 0
        LCD_Awrite("Datum   ");
        LCD_Zahl(sd_s_day,2,0);
        LCD_Awrite(".");
        LCD_Zahl(sd_s_month,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_s_year,4,0);
        LCD_Awrite("|");
        LCD_Write(PFEILRECHTS);                           
        sd_s_setup_show_time();                   // zeile 1, feststehende uhrzeit anzeigen
      break;
// seite 37 einstellen stunde
      case 37:
        sd_s_setup_show_date();                   // zeile 0, feststehendes datum anzeigen
        LCD_Cursor_Set(1,0);                      // zeile 1
        LCD_Awrite("Uhrzeit  |");
        LCD_Zahl(sd_s_hour,2,0);                          
        LCD_Awrite("|");                               
        LCD_Zahl(sd_s_min,2,0);                             
        LCD_Awrite(":00  ");                             
      break;
// seite 38 einstellen minute
      case 38:
        sd_s_setup_show_date();                   // zeile 0, feststehendes datum anzeigen
        LCD_Cursor_Set(1,0);                      // zeile 1
        LCD_Awrite("Uhrzeit   ");
        LCD_Zahl(sd_s_hour,2,0);                          
        LCD_Awrite("|");                                 
        LCD_Zahl(sd_s_min,2,0);                            
        LCD_Awrite("|00  ");                              
      break;                
// seite 39 setup endzeit sd-protokoll
      case 39:
        LCD_Cursor_Set(0,0); 
        LCD_Awrite("Setup ende sd-card  ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("               >>SET");
      break;
// seite 40 einstellen tag
      case 40:
        LCD_Cursor_Set(0,0);                      // zeile 0
        LCD_Awrite("Datum  |");
        LCD_Zahl(sd_e_day,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_e_month,2,0);
        LCD_Awrite(".");
        LCD_Zahl(sd_e_year,4,0);
        LCD_Awrite(" ");
        LCD_Write(PFEILRECHTS);                          
        sd_e_setup_show_time();                   // zeile 1, feststehende uhrzeit anzeigen
      break;
// seite 41 einstellen monat
      case 41:
        LCD_Cursor_Set(0,0);                      // zeile 0
        LCD_Awrite("Datum   ");
        LCD_Zahl(sd_e_day,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_e_month,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_e_year,4,0);
        LCD_Awrite(" ");
        LCD_Write(PFEILRECHTS);                          
        sd_e_setup_show_time();                   // zeile 1, feststehende uhrzeit anzeigen
      break;
// seite 42 einstellen jahr
      case 42:
        LCD_Cursor_Set(0,0);                      // zeile 0
        LCD_Awrite("Datum   ");
        LCD_Zahl(sd_e_day,2,0);
        LCD_Awrite(".");
        LCD_Zahl(sd_e_month,2,0);
        LCD_Awrite("|");
        LCD_Zahl(sd_e_year,4,0);
        LCD_Awrite("|");
        LCD_Write(PFEILRECHTS);                           
        sd_e_setup_show_time();                   // zeile 1, feststehende uhrzeit anzeigen
      break;
// seite 43 einstellen stunde
      case 43:
        sd_e_setup_show_date();                   // zeile 0, feststehendes datum anzeigen
        LCD_Cursor_Set(1,0);                      // zeile 1
        LCD_Awrite("Uhrzeit  |");
        LCD_Zahl(sd_e_hour,2,0);                          
        LCD_Awrite("|");                               
        LCD_Zahl(sd_e_min,2,0);                             
        LCD_Awrite(":00  ");                             
      break;
// seite 44 einstellen minute
      case 44:
        sd_e_setup_show_date();                   // zeile 0, feststehendes datum anzeigen
        LCD_Cursor_Set(1,0);                      // zeile 1
        LCD_Awrite("Uhrzeit   ");
        LCD_Zahl(sd_e_hour,2,0);                          
        LCD_Awrite("|");                                 
        LCD_Zahl(sd_e_min,2,0);                            
        LCD_Awrite("|00  ");                              
      break;
// seite 45 startsektor fuer sd-card
      case 45:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Startsektor SD-Card ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("zur");
        LCD_Write(BUCHSTABE_UE);
        LCD_Awrite("cksetzen   (SET)");        
      break;
// seite 46 einstellen startsektor fuer sd-card
      case 46:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("zur");
        LCD_Write(BUCHSTABE_UE);
        LCD_Awrite("cksetzen?  (770)");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("(");
        LCD_Write(PFEILLINKS);
        LCD_Awrite(")NEIN        JA(");
        LCD_Write(PFEILRECHTS);
        LCD_Awrite(")");
      break;                            
// seite 47 verlassen setup?
      case 47:
        LCD_Cursor_Set(0,0);                        // zeile 0
        LCD_Awrite("Setup verlassen?    "); 
        LCD_Cursor_Set(1,0);                        // zeile 1
        LCD_Awrite("(SET)Ja             ");
      break;
// seite 48 fehlerseite, falls protokollierung gerade laeuft --> dann keine einstellungen moeglich
      case 48:
        LCD_Cursor_Set(0,0);
        LCD_Awrite("Protokoll stoppen?  ");
        LCD_Cursor_Set(1,0);
        LCD_Awrite("(");
        LCD_Write(PFEILLINKS);
        LCD_Awrite(")NEIN        JA(");
        LCD_Write(PFEILRECHTS);
        LCD_Awrite(")");      
      break;                          
      //default:     
    } // ende switch-anweisung    
  }   // ende endlosschleife for (;;)
}     // ende main
// ************************************************************************************************
// ************************************************************************************************
// funktion zum initialisieren des C
// ************************************************************************************************
void init_mcu(void)
{
///////////////////////////////////////////////////////////////////////////////////////////////////
// defintion der einzelnen ports
///////////////////////////////////////////////////////////////////////////////////////////////////
// port1 einstellen                                 // port fr lcd
  P1DIR = 0xFF;                                     // alle pins auf ausgang setzen
  P1OUT = 0x00;                                     // alle pins auf null setzen
// port2 einstellen
  P2DIR = 0x7F;                                     // alle pins auf ausgang, bis auf P2.7
  P2OUT = 0x00;                                     // alle pins auf null setzen
// port3 einstellen                                 // port fr taster, peak-reset, SPI
  P3DIR = 0x00;                                     // alle pins von port3 auf eingang setzen
  P3SEL = SPI_DATA + SPI_CLOCK;                     // zweitverwendung der port-pins
  P3OUT = SPI_CS;                                   // alle pins von port3 auf null setzen, bis auf
                                                    // P3.2
  P3DIR = SPI_CS + PEAK_RESET;                      // SPI_CS und peak_reset auf ausgang setzen
// port4 einstellen
  P4DIR = 0xBE;                                     // alle pins auf ausgang setzen, bis auf P4.0
                                                    // und P4.6 (1011 1110 = 0xBE)
  P4OUT = 0x00;                                     // alle pins auf null setzen
// port5 einstellen                                 // port fr sd-card
  //P5DIR = 0x10;                                     // alle pins auf eingang setzen, bis auf P5.4
  //P5OUT = 0x00;                                     // alle pins auf null setzen
  
  P5SEL |= 0x0E;                                    // zweitfunktion setzen, 0000 1110
  P5SEL &= ~0x11;
  P5DIR |= 0x9A;                                    // alle pins auf ausgang setzen, bis auf P5.0
                                                    // P5.2, P5.5 und P5.6 (1001 1010)  
// port6 einstellen
  P6SEL |= 0x03;                                    // enable A/D channel A0 und A1; P6.0 & P6.1
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// initialsierung lcd
///////////////////////////////////////////////////////////////////////////////////////////////////   
  LCD_Init();                                       // LCD initialisieren ...
  LCD_Clear();                                      // ...loeschen, cursor an anfang
///////////////////////////////////////////////////////////////////////////////////////////////////
  LCD_Cursor_Set(0,0);                              // zeile 0
  LCD_Awrite("SPL-M2 Ver. : 0.1 by");
  LCD_Cursor_Set(1,0);                              // zeile 1
  LCD_Awrite("M. Unterstein       ");
  wait(32000);                                      // ...warten
  LCD_Cursor_Set(0,0);                              // zeile 0
  LCD_Write(BUCHSTABE_mue);                         // buchstabe "" ausgeben
  LCD_Awrite("Controller wird    ");
  LCD_Cursor_Set(1,0);                              // zeile 1
  LCD_Awrite("initialisiert...    ");
  wait(32000);                                      // ...warten
///////////////////////////////////////////////////////////////////////////////////////////////////
// ntige sachen fr SPI
///////////////////////////////////////////////////////////////////////////////////////////////////
  U0CTL  |= CHAR + SYNC + MM + SWRST;               // 8-bit, SPI, master, sw-reset enable
  U0TCTL |= CKPL + SSEL1 + STC;                     // Polarity, SMCLK, 3-wire
  U0BR0   = 0x002;                                  // Baud Rate Calc SPICLK = SMCLK/2 400KHz
  U0BR1   = 0x000;                                  // Baud Rate Calc
  U0MCTL  = 0x000;                                  // Modulation Control Register
  ME1    |= USPIE0;                                 // Module enable
  U0CTL  &= ~SWRST;                                 // SPI enable  
/////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////
// ntige sachen fr den ADC12
///////////////////////////////////////////////////////////////////////////////////////////////////
  ADC12CTL0 = ADC12ON+SHT0_2+REFON+REF2_5V;         // ADC12ON --> schaltet ad-wandler ein
                                                    // SHT0_2  --> clocks fr sample-time
                                                    // REFON   --> interne referenz an
                                                    // REF2_5  --> referenz auf 2.5V
  ADC12CTL1 = SHP;                                  // Use sampling timer
  wait(3600);                                       // wartezeit, damit referenzspannung steht...
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// erstmaliges hochfahren des PGAs
// PGA wird von -95.5dB (PGA_WERT_MIN = 1) bis 0dB (PGA_WERT_0dB = 192) durchgefahren
///////////////////////////////////////////////////////////////////////////////////////////////////
  for (BYTE i = PGA_WERT_MIN; i <= 170; i++) {pga_auf_wert(i); wait(1800);}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// timer b einstellen
///////////////////////////////////////////////////////////////////////////////////////////////////
/*
  TBCCTL0 = CCIE;                                   // CCR0 interrupt enabled
  TBCCR0  = ZEITBASIS;			            // wert in owndef, zaehl-zeit bis interrupt
  TBCTL   = TBSSEL0 + MC0;                          // ACLK, upmode
  _EINT();                                          // interrupt an
*/  
  
  CCR0  = ZEITBASIS; // ZEITBASIS = ((32768/8)-1) = 4095
  CCTL0 = CCIE;
  TACTL = TASSEL_1 + MC_1; // ACLK, up-mode
  _EINT(); 
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// den peak-detektor am anfang erstmal zuruecksetzen
///////////////////////////////////////////////////////////////////////////////////////////////////
  BitSetzen(3,PEAK_RESET);
  wait(3600);
  BitLoeschen(3,PEAK_RESET);
///////////////////////////////////////////////////////////////////////////////////////////////////
}// ende init_mcu()
// ************************************************************************************************
// ************************************************************************************************
// funktion fr eine warteschleife
// ************************************************************************************************
void wait(DWORD i)
{
  DWORD j;
  _NOP();                                           // einen Taktzyklus warten
  for(j=0;j<i;j++);
}
// ************************************************************************************************
// ************************************************************************************************
// funktion holt das aktuelle datum und die aktuelle zeit aus den TI bibliotheken und wandelt
// diese von bcd nach int...um damit einfacher "rechnen" zu knnen
// ************************************************************************************************
void get_date_and_time(void)
{
  int myday_h    = 0;                               // myday nibble high
  int myday_l    = 0;                               // myday nibble low
  int mymonth_h  = 0;                               // mymonth nibble high
  int mymonth_l  = 0;                               // mymonth nibble low
  int myyear_t   = 0;                               // myyear tausender
  int myyear_h   = 0;                               // myyear hunderter
  int myyear_z   = 0;                               // myyear zehner
  int myyear_e   = 0;                               // myyear einer
  int mysec_h    = 0;                               // mysec nibble high
  int mysec_l    = 0;                               // mysec nibble low
  int mymin_h    = 0;                               // mymin nibble high
  int mymin_l    = 0;                               // mymin nibble low
  int myhour_h   = 0;                               // myhour nibble high
  int myhour_l   = 0;                               // myhoue nibble low

  myday_h   = (TI_day >>4);                         // um 4 bit nach rechts shiften
  myday_l   = (TI_day & 0x0F);                      // maskieren mit 0000 1111
  myday     = myday_h*10 + myday_l;                 // variable zusammensetzen
  
  mymonth_h = (TI_month >> 4);                      // um 4 bit nach rechts shiften
  mymonth_l = (TI_month & 0x0F);                    // maskieren mit 0000 1111
  mymonth   = mymonth_h*10 + mymonth_l + 1;         // variable zusammensetzen
                                                    // + 1, weil monat bei 0 beginnt
  myyear_t  = ((TI_year >> 12) & 0x0F);             // um 12 bit nach rechts shiften und maskieren
  myyear_h  = ((TI_year >>  8) & 0x0F);             // um 8 bit nach rechts hiften und maskieren
  myyear_z  = ((TI_year >>  4) & 0x0F);             // um 4 bit nach rechts shiften und maskieren
  myyear_e  = (TI_year & 0x0F);
  myyear    = myyear_t*1000 + myyear_h*100 + myyear_z*10 + myyear_e;   // variable zusammensetzen

  mysec_h  = (TI_second >> 4);                      // um 4 bit nach rechts shiften  
  mysec_l  = (TI_second & 0x0F);                    // maskieren mit 0000 1111
  mysec    = mysec_h*10 + mysec_l;                  // variable zusammensetzen
  
  mymin_h  = (TI_minute >> 4);                      // um 4 bit nach rechts shiften
  mymin_l  = (TI_minute & 0x0F);                    // maskieren mit 0000 1111
  mymin    = mymin_h*10 + mymin_l;                  // variable zusammensetzen
  
  myhour_h = (get24Hour() >> 4);                    // um 4 bit nach rechts shiften
  myhour_l = (get24Hour() & 0x0F);                  // maskieren mit 0000 1111
  myhour   = myhour_h*10 + myhour_l;                // variable zusammensetzen
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zeigt das datum beim setup des datums und der uhrzeit in der ersten zeile an
// -- nur um code-zeilen zu sparen
// ************************************************************************************************
void setup_show_date(void)
{
  LCD_Cursor_Set(0,0);                              // zeile 0
  LCD_Awrite("Datum   ");                          
  LCD_Zahl(myday,2,0);
  LCD_Awrite(".");
  LCD_Zahl(mymonth,2,0);
  LCD_Awrite(".");
  LCD_Zahl(myyear,4,0);
  LCD_Awrite(" ");
  LCD_Write(PFEILRECHTS);                         
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zeigt die uhrzeit beim setup des datums und der uhrzeit in der zweiten zeile an
// -- nur um code-zeilen zu sparen
// ************************************************************************************************
void setup_show_time(void)
{
  LCD_Cursor_Set(1,0);                              // zeile 1
  LCD_Awrite("Uhrzeit   ");
  LCD_Zahl(myhour,2,0);
  LCD_Awrite(":");
  LCD_Zahl(mymin,2,0);
  LCD_Awrite(":");
  LCD_Zahl(mysec,2,0);
  LCD_Awrite("  ");
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zeigt die uhrzeit beim setup des startdatums fr sd-card-protokoll in zweiter zeile an
// -- nur um code-zeilen zu sparen
// ************************************************************************************************
void sd_s_setup_show_date(void)
{
  LCD_Cursor_Set(0,0);                              // zeile 0
  LCD_Awrite("Datum   ");                          
  LCD_Zahl(sd_s_day,2,0);
  LCD_Awrite(".");
  LCD_Zahl(sd_s_month,2,0);
  LCD_Awrite(".");
  LCD_Zahl(sd_s_year,4,0);
  LCD_Awrite(" ");
  LCD_Write(PFEILRECHTS);                         
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zeigt die uhrzeit beim setup der startzeit fr sd-card-protokoll in zweiter zeile an
// -- nur um code-zeilen zu sparen
// ************************************************************************************************
void sd_s_setup_show_time(void)
{
  LCD_Cursor_Set(1,0);                              // zeile 1
  LCD_Awrite("Uhrzeit   ");
  LCD_Zahl(sd_s_hour,2,0);
  LCD_Awrite(":");
  LCD_Zahl(sd_s_min,2,0);
  LCD_Awrite(":00  ");
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zeigt die uhrzeit beim setup des enddatums fr sd-card-protokoll in zweiter zeile an
// -- nur um code-zeilen zu sparen
// ************************************************************************************************
void sd_e_setup_show_date(void)
{
  LCD_Cursor_Set(0,0);                              // zeile 0
  LCD_Awrite("Datum   ");                          
  LCD_Zahl(sd_e_day,2,0);
  LCD_Awrite(".");
  LCD_Zahl(sd_e_month,2,0);
  LCD_Awrite(".");
  LCD_Zahl(sd_e_year,4,0);
  LCD_Awrite(" ");
  LCD_Write(PFEILRECHTS);                         
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zeigt die uhrzeit beim setup der endzeit fr sd-card-protokoll in zweiter zeile an
// -- nur um code-zeilen zu sparen
// ************************************************************************************************
void sd_e_setup_show_time(void)
{
  LCD_Cursor_Set(1,0);                              // zeile 1
  LCD_Awrite("Uhrzeit   ");
  LCD_Zahl(sd_e_hour,2,0);
  LCD_Awrite(":");
  LCD_Zahl(sd_e_min,2,0);
  LCD_Awrite(":00  ");
}
// ************************************************************************************************
// ************************************************************************************************
// funktion wandelt einen 2-stelligen dezimalwert in einen bcd-wert um
// ist ntig, um diesen wert dann ans display zu senden, da setTime() anscheinend nur mit
// bcd-werten gefttert werden kann
// ************************************************************************************************
int dez2bcd (int wert_dez)
{
  int wert_bcd;
  wert_bcd = ((wert_dez/10)*16) + wert_dez%10;
  return(wert_bcd);
}
// ************************************************************************************************
// ************************************************************************************************
// funktion um neu eingestelltes datum und uhrzeit zu setzen
// ************************************************************************************************
void set_date_and_time(void)
{
  char myhourBCD  = 0;
  char myminBCD   = 0;
  char mysecBCD   = 0;
  int myhour12    = 0;        
  if (myhour > 12) myhour12 = myhour - 12;          // hour intern 0...11, nachmittag ber AM/ PM
  else myhour12 = myhour;
  myhourBCD = dez2bcd(myhour12);                    // BCD-wert holen
  myminBCD  = dez2bcd(mymin);                       // BCD-wert holen
  mysecBCD  = dez2bcd(mysec);                       // BCD-wert holen
  setTime(myhourBCD, myminBCD, mysecBCD, myPM);     // aufruf setTime() mit neuen werten
  setDate(myyear, (char)mymonth, (char)myday);      // aufruf setDate() mit neuen werten
  Seite = 5;                                        // dann zurck zur seite 5 gehen
}
// ************************************************************************************************
// ************************************************************************************************
// funktion berprft den status der sd_card
// sd_card_status == 1 --> karte nicht drin
// sd_card_status == 2 --> karte drin, aber schreibschutz aktiv
// sd_card_status == 3 --> alles OK
// ************************************************************************************************
char check_sd_card_status(void)
{  
  P5OUT |= SW1;                                     // SW1 auf high
  if ((P5IN & SW3) == 0x20)                         // test, ob SW3 auf high
  {
    if ((P5IN & SW2) == 0x40)                       // test, ob SW2 auf high
      sd_card_status = 3;                           // --> alles OK
    else sd_card_status = 2;                        // --> karte drin, aber schreibschutz aktiv
  }
  else sd_card_status = 1;                          // --> karte nicht drin
  
  P5OUT &= ~SW1;                                    // SW1 wieder auf low
  return (sd_card_status);
}  
// ************************************************************************************************
// ************************************************************************************************
// funktion, um die logarithmierten werte auf eine nachkommastelle zu runden
// macht z.b. aus 6683 --> 668 (== 66,8dB); aus 6898 --> 690 (== 69,0dB)
// ************************************************************************************************
WORD runden(WORD zahl)
{
  WORD nk = zahl%10;                                // modulo 10 --> rest der division durch 10
  if (nk < 5) return zahl/10;
  else return (zahl/10) + 1;
}
// ************************************************************************************************
// ************************************************************************************************
// funktion, um den PGA auf den minimalen wert von -95.5dB zu setzen
// ************************************************************************************************
void pga_auf_wert(BYTE wert)
{
  PGA_WERT = wert;                                  // damit man weiss, wo der PGA gerade steht...
  BitLoeschen(3,SPI_CS);		            // chip select (low aktiv) setzen
  TXBUF0 = wert; 	         	            // wert rechter Kanal senden
  while(!(UTCTL0 & TXEPT));                    // transmit control register und transmit-empty flag  
  TXBUF0 = wert; 		                    // Wert linker kanal senden
  while(!(UTCTL0 & TXEPT));		            // transmitter empty
  BitSetzen(3,SPI_CS);		                    // chip select (low aktiv) lschen
}  
// ************************************************************************************************
// ************************************************************************************************
// funktion, um alle variablen fr adc12 zurueckzusetzen
// hier werden alle variablen fuer die ad-wandlung zurueckgesetzt, damit beim starten der wandlung
// fuer die kalibrierung nicht falsche werte entstehen...
// ************************************************************************************************
void setze_alle_adc12_zurueck(void)
{
Tick      = 0;

tnext     = 0;
t1next    = 0;
t5next    = 0;
t1mnext   = 0;
t30mnext  = 0;

teiler_1s   = 0;
teiler_5s   = 0;
teiler_1m   = 0;
teiler_30m  = 0;

Lequ      = 0;
Lequ_1s   = 0;
Lequ_5s   = 0;
Lequ_1m   = 0;
Lequ_30m  = 0;

Lpeak         = 0;
Lpeak_1s      = 0;
Lpeak_1s_neu  = 0;
Lpeak_5s      = 0;
Lpeak_5s_neu  = 0;
Lpeak_1m      = 0;
Lpeak_1m_neu  = 0;
Lpeak_30m     = 0;
Lpeak_30m_neu = 0;

Summe_Lequ      = 0;
Summe_Lequ_5s   = 0;
Summe_Lequ_1m   = 0;
Summe_Lequ_30m  = 0;

Kalib_Lequ                = 0;
Kalib_Summe_Lequ          = 0;
Kalib_Summe_Lequ_5s       = 0;
Kalib_diff_erstes_messen  = 7000;
}
// ************************************************************************************************
// ************************************************************************************************
// funktion zum lschen des buffers; buffer wird mit nullen gefllt
// ************************************************************************************************
void loesche_buffer(void) {for (int z=0; z<512; z++) buffer[z] = 0;}
// ************************************************************************************************
// ************************************************************************************************
// funktion zum beschreiben des buffers mit dem kopf der protokollierung
// ************************************************************************************************
void schreibe_protokoll_kopf(void)
{
  loesche_buffer();                                 // lscht den buffer
  strcat (buffer, "\r\n");                          // zeilenumbruch
  strcat (buffer, "**************************");    // string schreiben
  strcat (buffer, "\r\n");
  strcat (buffer, "Protokoll des Schallpegels");
  strcat (buffer, "\r\n");
  strcat (buffer, "\r\n");
  strcat (buffer, "Startzeit:  ");
  strcat (buffer, zahl2ascii(sd_s_day));
  strcat (buffer, ".");
  strcat (buffer, zahl2ascii(sd_s_month));
  strcat (buffer, ".");
  strcat (buffer, zahl2ascii(sd_s_year-2000));
  strcat (buffer, " ");
  strcat (buffer, zahl2ascii(sd_s_hour));
  strcat (buffer, ":");
  strcat (buffer, zahl2ascii(sd_s_min));
  strcat (buffer, "\r\n");
  strcat (buffer, "Endzeit:    ");
  strcat (buffer, zahl2ascii(sd_e_day));
  strcat (buffer, ".");
  strcat (buffer, zahl2ascii(sd_e_month));
  strcat (buffer, ".");
  strcat (buffer, zahl2ascii(sd_e_year-2000));
  strcat (buffer, " ");
  strcat (buffer, zahl2ascii(sd_e_hour));
  strcat (buffer, ":");
  strcat (buffer, zahl2ascii(sd_e_min));
  strcat (buffer, "\r\n");
  strcat (buffer, "\r\n");
  if      (Mode == 1) strcat (buffer, "Mode:            Line-Mode");
  else if (Mode == 2) strcat (buffer, "Mode:             Mic-Mode");
  strcat (buffer, "\r\n");
  strcat (buffer, "\r\n");
  strcat (buffer, "Die dargestellten Minuten-");
  strcat (buffer, "\r\n");
  strcat (buffer, "werte sind als xxx,x dB zu");
  strcat (buffer, "\r\n");
  strcat (buffer, "interpretieren.");
  strcat (buffer, "\r\n");
  strcat (buffer, "\r\n");
  strcat (buffer, "Ein '*' signalisiert, dass");
  strcat (buffer, "\r\n");
  strcat (buffer, "die Dmpfung des PGA");
  strcat (buffer, "\r\n");
  strcat (buffer, "manuell verringert wurde!");
  strcat (buffer, "\r\n");
  strcat (buffer, "\r\n");
  if      (Wichtung == 1) strcat (buffer, "LequA");
  else if (Wichtung == 2) strcat (buffer, "LequB");
  else if (Wichtung == 3) strcat (buffer, "Lequc");
  strcat (buffer, " ");
  strcat (buffer, "LpeakC");
  // dann die sache per mmcwrite auf die sd-card schreiben...  
  mmcWriteSector(sektor, (unsigned char*) buffer);  // schreibt buffer_1 in sektor auf sd-card
  ++sektor;                                         // sektor erhhen
  loesche_buffer();                                 // lscht den buffer
  protokoll_kopf_geschrieben = 1;                   // anzeige, dass der kopf geschrieben wurde
  setze_alle_adc12_zurueck();                       // damit die ad-wandlung in etwa synchron zur
                                                    // uhrzeit laeuft, wird die sache genau EINMAL
}                                                   // zurueckgesetzt
// ************************************************************************************************
// ************************************************************************************************
// funktion wandelt 2stellige zahl in ascii-string um
// zum schreiben des datums und der uhrzeit auf die sd-card
// ************************************************************************************************
char* zahl2ascii (int zahl)
{
  int i = 2;
  char string[3] = "00";                            // 2 zeichen plus endezeichen
  
  do
  {
    string[--i] = (zahl%10) + 0x30;                 // 1er stelle abspalten
    zahl = zahl/10;                                 // 10er stelle abspalten
  } while(i);

  return (string);
}
// ************************************************************************************************
// ************************************************************************************************
// funktion wandelt 4stellige zahl in ascii-string um (mit vorrangestellten nullen)
// zum schreiben der pegelwerte auf die sd-card
// ************************************************************************************************
char* zahl2ascii2 (WORD zahl)
{
  int i = 4;
  char string[5] = "0000";
  
  do
  {
    string[--i] = (zahl%10) + 0x30;
    zahl = zahl/10;
  } while(i);

  return (string);
}
// ************************************************************************************************
// ************************************************************************************************
// interrupt routinen
// ************************************************************************************************
/*
// timer_b interrupt service routine
#pragma vector=TIMERB0_VECTOR
__interrupt void Timer_B (void)
{
  if (Tick == (32768/ZEITBASIS)) Tick = 0;        // timer zurcksetzen
  else Tick++;
}
*/

// timer_a interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
  if (Tick == 8) {Tick = 0; incrementSeconds();}
  else Tick = Tick + 1;
}
// ************************************************************************************************
