#ifndef MY_GLOBALS_H
#define MY_GLOBALS_H

// ************************************************************************************************
// definition globaler variablen
// ************************************************************************************************
int myday, mymonth, myyear, mysec, mymin, myhour;   // variablen fr datum und uhrzeit
char myPM        = 0;                               // vormittag (0), oder nachmittag (1)

char Seite       = 4;                               // variable fr seitennummerierung auf display

WORD Regelgrenze = 9900;                           // regelgrenze auf den geregelt wird = 99dB

BYTE Mode        = 2;                               // line-mode(1) oder mic-mode(2)
BYTE Wichtung    = 1;                               // a-bew.(1), b-bew.(2), oder c-bew.(3)

int K_LequA      = 0;                               // korrekturwert fr a-gewicht. dauerpegel
int K_LequB      = 0;                               // korrekturwert fr b-gewicht. dauerpegel
int K_LequC      = 0;                               // korrekturwert fr c-gewicht. dauerpegel
int K_LpeakC     = 0;                               // korrekturwert fr c-gewicht. spitzenpegel

// sachen fuer die sd--card
// variablen fr start- und endzeit sd-card-protokollierung
int  sd_s_day    = 1;                               // starttag
int  sd_s_month  = 1;                               // startmonat
int  sd_s_year   = 2007;                            // startjahr
int  sd_s_min    = 0;                               // startminute
int  sd_s_hour   = 0x01;                            // startstunde
int  sd_s_hour12 = 0;                               // hilfvariable
char sd_s_PM     = 0;                               // variable fr vormittag/ nachmittag
int  sd_e_day    = 1;                               // endtag
int  sd_e_month  = 1;                               // endmonat
int  sd_e_year   = 2007;                            // endjahr
int  sd_e_min    = 0;                               // endminute
int  sd_e_hour   = 0x01;                            // endstunde
int  sd_e_hour12 = 0;                               // hilfsvariable
char sd_e_PM     = 0;                               // variable fr vormittag/ nachmittag

char sd_s_gesetzt= 0;                               // anzeige, ob startzeit gesetzt wurde
char sd_e_gesetzt= 0;                               // anzeige, ob endzeit gesetzt wurde

BYTE protokoll_laeuft    = 0;                       // anzeige, ob protokollierung laeuft (1==ja)
BYTE protokoll_kopf_geschrieben = 0;                // anzeige, dass kopf geschrieben wurde (1==ja)
BYTE sd_card_status  = 1;                           // test, ob karte drin oder ob schreibschutz...
unsigned int sektor  = 770;                         // startsektor zum schreiben auf sd-card
char buffer[512];                                   // buffer, der gefuellt wird, um dann auf die
                                                    // sd-card geschrieben zu werden
BYTE status = 1;                                    // status-variable beim init. der sd-card
BYTE timeout = 0;

// sachen fr die ad-wandlung
static BYTE Tick    = 0;                            // tick-zaehler

BYTE protokoll_t1mnext = 0;
BYTE protokoll_zaehler = 0;                         // schleifenzaehler fuer die protokollierung

BYTE tnext          = 0;
BYTE t1next         = 0;                            // 8* 125ms
BYTE t5next         = 0;                            // 5s
BYTE t10next        = 0;                            // 10s
BYTE t20next        = 0;                            // 20s
BYTE t30next        = 0;                            // 30s
BYTE t40next        = 0;                            // 40s
BYTE t50next        = 0;                            // 50s
BYTE t1mnext        = 0;                            // 60s
WORD t30mnext       = 0;                            // 3600s

BYTE teiler_1s      = 0;                            // teiler fuer 1s, --> wird    (1s*8) = 8
BYTE teiler_5s      = 0;                            // teiler fuer 5s, --> wird    (5s*8) = 40
BYTE teiler_10s     = 0;                            // teiler fuer 10s, --> wird   (10s*8) = 80
BYTE teiler_20s     = 0;                            // teiler fuer 20s, --> wird   (20s*8) = 160
BYTE teiler_30s     = 0;                            // teiler fuer 30s, --> wird   (30s*8) = 240
WORD teiler_40s     = 0;                            // teiler fuer 40s, --> wird   (40s*8) = 320
WORD teiler_50s     = 0;                            // teiler fuer 50s, --> wird   (50s*8) = 400
WORD teiler_1m      = 0;                            // teiler fuer 1min, --> wird  (60s*8) = 480
WORD teiler_30m     = 0;                            // teiler fuer 30min, --> wird (1800s*8) = 14400

WORD adcwert        = 0;                            // wandlerwert des 1. kanals (eff)
WORD adcwert1       = 0;                            // wandlerwert des 2. kanals (peak)
WORD sum_adcwert_1s = 0;                            // summe wandlerwerte 1. kanal
WORD sum_adcwert1_1s= 0;                            // summe wandlerwerte 2. kanal
WORD mw_adcwert_1s  = 0;                            // mittelwert wandlerwerte kanal 1 ueber 1s
WORD mw_adcwert1_1s = 0;                            // mittelwert wandlerwerte kanal 2 ueber 1s

WORD Lequ           = 0;                            // aktueller schallpegel (eff)
WORD Lequ_1s        = 0;                            // gemittelter schallpegel ueber 1s
WORD Lequ_5s        = 0;                            // gemittelter schallpegel ueber 5s
WORD Lequ_10s       = 0;                            // gemittelter schallpegel ueber 10s
WORD Lequ_20s       = 0;                            // gemittelter schallpegel ueber 20s
WORD Lequ_30s       = 0;                            // gemittelter schallpegel ueber 30s
WORD Lequ_40s       = 0;                            // gemittelter schallpegel ueber 40s
WORD Lequ_50s       = 0;                            // gemittelter schallpegel ueber 50s
WORD Lequ_1m        = 0;                            // gemittelter schallpegel ueber 1min
WORD Lequ_30m       = 0;                            // gemittelter schallpegel ueber 30min
WORD Lpeak          = 0;                            // aktueller spitzenschallpegel
WORD Lpeak_1s       = 0;                            // spitzenschallpegel 1s
WORD Lpeak_1s_neu   = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_5s       = 0;                            // spitzenschallpegel 5s
WORD Lpeak_5s_neu   = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_10s      = 0;                            // spitzenschallpegel 10s
WORD Lpeak_10s_neu  = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_20s      = 0;                            // spitzenschallpegel 20s
WORD Lpeak_20s_neu  = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_30s      = 0;                            // spitzenschallpegel 30s
WORD Lpeak_30s_neu  = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_40s      = 0;                            // spitzenschallpegel 40s
WORD Lpeak_40s_neu  = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_50s      = 0;                            // spitzenschallpegel 50s
WORD Lpeak_50s_neu  = 0;                            // variable fuer anzeige des spitzenpegels
WORD Lpeak_1m       = 0;                            // spitzenpegel 1min
WORD Lpeak_1m_neu   = 0;                            // variable fuer speicherung des spitzenpegels
WORD Lpeak_30m      = 0;                            // spitzenschallpegel 30min
WORD Lpeak_30m_neu  = 0;                            // variable fuer anzeige des spitzenpegels

QWORD Summe_Lequ    = 0;                            // summe der in spannungen zurueckgewandelten..                                                   
QWORD Summe_Lequ_5s = 0;                            // ...werte zur bestimmung des mittelungspegels
QWORD Summe_Lequ_10s= 0;
QWORD Summe_Lequ_20s= 0;
QWORD Summe_Lequ_30s= 0;
QWORD Summe_Lequ_40s= 0;
QWORD Summe_Lequ_50s= 0;
QWORD Summe_Lequ_1m = 0;
QWORD Summe_Lequ_30m= 0;

WORD Kalib_Lequ     = 0;
WORD Kalib_LequA    = 0;
WORD Kalib_LequB    = 0;
WORD Kalib_LequC    = 0;
WORD Kalib_Lpeak    = 0;
WORD Kalib_LpeakC   = 0;

WORD Kalib_LequA_el     = 0;
WORD Kalib_LequA_el_1s  = 0;
WORD Kalib_LequA_el_1s_neu  = 0;
WORD Kalib_LequA_el_5s  = 0;
WORD Kalib_LequA_el_5s_neu  = 0;

WORD Kalib_LequB_el     = 0;
WORD Kalib_LequB_el_1s  = 0;
WORD Kalib_LequB_el_1s_neu  = 0;
WORD Kalib_LequB_el_5s  = 0;
WORD Kalib_LequB_el_5s_neu  = 0;

WORD Kalib_LequC_el     = 0;
WORD Kalib_LequC_el_1s  = 0;
WORD Kalib_LequC_el_1s_neu  = 0;
WORD Kalib_LequC_el_5s  = 0;
WORD Kalib_LequC_el_5s_neu  = 0;

WORD Kalib_LpeakC_el    = 0;
WORD Kalib_LpeakC_el_1s = 0;
WORD Kalib_LpeakC_el_1s_neu = 0;
WORD Kalib_LpeakC_el_5s = 0;
WORD Kalib_LpeakC_el_5s_neu = 0;

QWORD Kalib_Summe_Lequ    = 0;
QWORD Kalib_Summe_Lequ_5s = 0;

int Gain_eff_A      = 0;
int Gain_eff_B      = 0;
int Gain_eff_C      = 0;
//int Gain_peak_C     = 0;

int delta           = 0;
int delta_1         = 0;
int delta_2         = 0;
int Gain_aktuell    = 0;

BYTE kalibrierung_laeuft      = 0;                  // anzeige, ob kalibrierung laeuft (1==ja)
BYTE kalibrierung_a_bewertet  = 0;                  // variable fuer anzeige "kalibrierung laeuft"
BYTE kalibrierung_b_bewertet  = 0;                  // variable fuer anzeige "kalibrierung laeuft"
BYTE kalibrierung_c_bewertet  = 0;                  // variable fuer anzeige "kalibrierung laeuft"

BYTE PGA_WERT                 = 170;                // entspricht einer verstaerkung von 0dB
BYTE taster_pga_gedrueckt     = 0;                  // anzeige, ob taster gedrueckt wurde waehrend
                                                    // der protokollierung
BYTE line           = 0;                        // nur eine testvariable frs umschalten line/noise

WORD Kalib_Regelgrenze        = 8000;               // regelgrenze fuer kalibrierung = 80dB
WORD Kalib_diff_erstes_messen = 7000;               // differenz beim erstmaligen messen des
                                                    // schallpegels, weil sonst sofort regelgrenze
                                                    // ueberschritten wird!
                                                    // siehe main.c --> "durchfahren des pga" 
#endif
